pro assigngrid
;
; finds arrays idy(npix,nptin), idz(npix,nptin) in common
; block wherepoint. These are the pointing directions on the natural grid
; in units of the natural grid identifier.
;
;common steer1,npix,pixsize,pixpitch,pixoff,nchop,dcy,dry,drz
;common steerin,array,nptin,npt,ninramp,imeas,osamp
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
;common plotter,otfstart,otfstop,rdstat,chop,step,otf,rpid,yrel,zrel,$
;ytrue,ztrue,yzrpidcen,nyraster,nzraster
;common wherepoint,idy,idz
;
@common_steer1
@common_steerin
@common_mapper
@common_plotter
@common_wherepoint
;
idy=lonarr(npix,nptin)
idz=idy
;
; calculate which map pixel each data point belongs to
;
evenodd,nygrid,iyodd
if(iyodd eq 1)then begin ; find map pixel identifiers idy for map columns
idy=round(ytrue/sgridy)
idy=idy+nygrid/2
endif ; iyodd
if(iyodd ne 1)then begin ; even number of map columns
idy=round((ytrue/sgridy)-0.5)
idy=idy+nygrid/2
endif ; iyodd
evenodd,nzgrid,izodd
if(izodd eq 1)then begin ; find map pixel identifiers idz for map rows
idz=round(ztrue/sgridz)
idz=idz+nzgrid/2
endif ; izodd
if(izodd ne 1)then begin ; even number of map rows
idz=round((ztrue/sgridz)-0.5)
idz=idz+nzgrid/2
endif ; izodd
if(min(idy) lt 0 or max(idy) gt nygrid-1)then begin
print,'ASSIGNGRID: warning - data outside grid in Y'
print,' sgridy,nygrid,min(idy),max(idy) = ',sgridy,nygrid,$
min(idy),max(idy) 
endif ; min(idy)
if(min(idz) lt 0 or max(idz) gt nzgrid-1)then begin
print,'ASSIGNGRID: warning - data outside grid in Z'
print,' sgridz,nzgrid,min(idz),max(idz) = ',sgridz,nzgrid,$
min(idz),max(idz) 
endif ; min(idz)
;
return
end
