pro compare,map1,mapn1,map2,mapn2,const,slope
;
; finds factors const and slope such that map1 * slope + constant = map2
; where the comparison is done on points with 
; amount of data > (average per pixel) * wfraction
;
; input: map1(nygrid,nzgrid)  = brightness
;        map1n(nygrid,nzgrid) = number of data samples in each map pixel
;        map2, map2n as above
;
common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
wfraction=0.5
imap1=lonarr(nygrid,nzgrid) 
imap2=imap1
n1=total(mapn1)
xnthresh1=float(n1)/float(nygrid*nzgrid)
xnthresh1=xnthresh1*wfraction
n2=total(mapn2)
xnthresh2=float(n2)/float(nygrid*nzgrid)
xnthresh2=xnthresh2*wfraction
imap1=where(float(mapn1) gt xnthresh1,nimap1)
imap2=where(float(mapn2) gt xnthresh2,nimap2)
if(nimap1 le 0)then $
print,'COMPARE: no points with sufficient weights: nimap1 = ',nimap1
if(nimap2 le 0)then $
print,'COMPARE: no points with sufficient weights: nimap2 = ',nimap2
;print,'nimap1,nimap2 = ',nimap1,nimap2
xx=dblarr(nygrid*nzgrid)
yy=xx
nc=-1
for i=0,nygrid-1 do begin
for j=0,nzgrid-1 do begin
if(float(mapn1(i,j)) gt xnthresh1 and float(mapn2(i,j)) gt xnthresh2)then begin
nc=nc+1
xx(nc)=map1(i,j)
yy(nc)=map2(i,j)
endif ; float(mapn1(i,j)) gt xnthresh1 and float(mapn2(i,j)) gt xnthresh2
endfor ; j
endfor ; i
;
x=dblarr(nc)
y=x
x(*)=xx(0:nc-1)
y(*)=yy(0:nc-1)
; don't include rogue points (eg influenced by source or drifts)
a=poly_fit(x,y,1)
yr=y-a(0)-a(1)*x ; residuals
findsigma,yr,sigma
iii=where(abs(yr) lt 3.0*sigma,niii)
y=y(iii)
x=x(iii)
; 
; fit remaining data
window,28,xs=400,ys=400
xmin=min([0.0,min(x)])
ymin=min([0.0,min(y)])
plot,x,y,xran=[xmin,max(x)],yran=[ymin,max(y)],psym=1
a=poly_fit(x,y,1)
const=a(0)
slope=a(1)
x1=xmin
x2=max(x)
y1=a(0)+a(1)*x1
y2=a(0)+a(1)*x2
oplot,[x1,x2],[y1,y2],linestyle=0
;
return
end
