pro compositeillchi,mskc,ermsc,respcorrc,modelfitc,isquare,illchi
;
; finds a quasi chi-squared goodness of fit ILLCHI between the predicted 
; illumination from a central simulated point source (contained in the array 
; ILLSIM in common PSSIM and the current estimate of illumination from 
; DRIFTCORR calculated from RESPCORRC and MODELFITC. Note that 
; RESPCORRC*MODELFITC is the actual illumination on detector, slightly less 
; than the SKY incident radiation due to the vignetting. This is the same 
; situation as for ILLSIM so they are directly comparable.
;
; at present ISQUARE options not yet implemented
;
@common_pssim
;common pssim,psflux,psmap,vsmap,psconv1,psconv2,compositeweight,illsim
;
;save,/xdr,mskc,ermsc,respcorrc,modelfitc,isquare,$
;file='compositeillchi.xdr'
;
ii=where(mskc eq 0,nii)
xnii=float(nii)
if(nii lt 2)then begin
print,'COMPOSITEILLCHI **** aborting because less than 2 good points'
goto, c999
endif ; nii lt 2
;
rmsmean=total(ermsc(ii))/xnii
x=(respcorrc(ii)*modelfitc(ii)-illsim(ii))/rmsmean
illchi=sqrt(total(x*x)/xnii)
;
c999:
;
return
end