pro createback,backsim,sx,sy,nx,ny,z
;
; creates a 2D planar background in the array Z (real, dimensions NX * NY) 
; SX and SY is the pixel sampling in arcsec. The routine avoids a 2D DO loop.
; The background at pixel IX,IY (IDL notation) is specified as:
; BACKSIM(0) + SX*(IX-LONG(NX)/2)*BACKSIM(1) + SZ*(IY-LONG(NY)/2)*BACKSIM(2)
; Units of backsim are per square arcsec. The units of z are per
; area SX * SY
;
; offset X from map centre in arcsec (only equal to real map centre for NX odd)
col=backsim(1)*(findgen(nx)-float(nx/2))*sx
row=backsim(2)*(findgen(ny)-float(ny/2))*sy
;print,'col:'col
;print,'row:'row
;if(n_elements(z(*,0)) ne nx or n_elements(z(0,*)) ne ny)then z=fltarr(nx,ny)
z=fltarr(nx,ny)
for irow=0,ny-1 do begin
z(*,irow)=row(irow) + col(*)
endfor ; irow
Z=Z+BACKSIM(0)
Z=Z*SX*SY ; to get background in units per map pixel area.
;
return
end

