pro detselfcal,iparsolve_in,icalmethod,idefcal,icalpt1,icalpt2,ipix,chimin,$
bestsky,nbestsky,$
betaout,tauout,gammaexpout,betashootout,taushootout,gammaexpshootout,$
betacoeffout,$
betaexpout,tauoffsetout,betacoeffshootout,betaexpshootout,tauoffsetshootout,$
signal0,signalshoot0,sillum0,$
ngrid,from,to,nplat,nplateau,vigp,keyp,finep,pident,$
keypoint,fpoint,itrans,ech,$
eyt,ezt,msk,vig,t,signal,erms,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfit,respcorr,maskout,niter,ndetinit,nplatinit,$
nlookback,backminvthispix,backpred,backpredvthispix,icompositecorr
;
;
; backpred in MJy/sr; backpredvthispix in V/s uncorrected for non-linearity
;
; multidimensional cut optimization routine to
; find minimum value CHIMIN of a fit to pointing range ICALPT1 to ICALPT2 (1D)
; for a combination of beta tau gammaexp. Any combination of
; beta tau gammaexp can be searched for according to the value of the
; IPARSOLVE array. eg all parameters are searched for if IPARSOLVE=[1,1,1]
; see DRIFTCORR for input parameter definitions
;
;common_morepar,gammaexp,zerobias,betashoot,taushoot,gammaexpshoot,$
;betacoeffshoot,betaexpshoot,tauoffsetshoot,tauoffset,betaexp,betacoeff
@common_mapper
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
@common_pssim
;common pssim,psflux,psmap,vsmap,psconv1,psconv2,compositeweight,illsim
@common_names
;common names,tdtnam,iseq,dirnam,caldir,cfilter 
@common_morepar
@common_testdriftcorr
;common testdriftcorr,skyfound,skyfoundfitres,skyfoundnpt,skypass,nskyfound,$
;ndimsky,skyfoundplat,platskyuse
@common_timer
;common timer,time,dtime,complete
@common_steerin
;common steerin,array,nptin,npt,ninramp,imeas,osamp
@common_detcal
;common detcal,betadef,taudef,gammaexpdef,$
;betashootdef,taushootdef,gammaexpshootdef,$
;betacoeffdef,betaexpdef,tauoffsetdef,$
;betacoeffshootdef,betaexpshootdef,tauoffsetshootdef,$
;betaupsc,betadownsc,tauupsc,taudownsc,gammaexpupsc,gammaexpdownsc,$
;betashootupsc,betashootdownsc,taushootupsc,taushootdownsc,$
;gammaexpshootupsc,gammaexpshootdownsc,$
;betacoeffupsc,betacoeffdownsc,betaexpupsc,betaexpdownsc,$
;tauoffsetupsc,tauoffsetdownsc,betacoeffshootupsc,betacoeffshootdownsc,$
;betaexpshootupsc,betaexpshootdownsc,tauoffsetshootupsc,tauoffsetshootdownsc
@common_detdefault
;common detdefault,betadefault,taudefault,gammaexpdefault,$
;betashootdefault,taushootdefault,gammaexpshootdefault,$
;betacoeffdefault,betaexpdefault,tauoffsetdefault,$
;betacoeffshootdefault,betaexpshootdefault,tauoffsetshootdefault,$
;betaup,betadown,tauup,taudown,gammaexpup,gammaexpdown,$
;betashootup,betashootdown,taushootup,taushootdown,$
;gammaexpshootup,gammaexpshootdown,$
;betacoeffup,betacoeffdown,betaexpup,betaexpdown,$
;tauoffsetup,tauoffsetdown,betacoeffshootup,betacoeffshootdown,$
;betaexpshootup,betaexpshootdown,tauoffsetshootup,tauoffsetshootdown,$
;betaprec,tauprec,gammaexpprec,betashootprec,taushootprec,gammaexpshootprec,$
;betacoeffprec,betaexpprec,tauoffsetprec,$
;betacoeffshootprec,betaexpshootprec,tauoffsetshootprec
;
; note - in the common_detdefault only the betaprec,tauprec etc parameters
; are used by DETSELFCAL. Take care not to overwrite any of the 
; arrays betadefault,taudefault etc and betaup,betadown,tauup,taudown etc
; in DETSELFCAL; these parameters are passed as scalars in COMMON_DETCAL.
;
@common_detpars
;common detpars,betaoverride,tauoverride,gammaexpoverride,$
;betashootoverride,taushootoverride,gammaexpshootoverride,$
;betacoeffoverride,betaexpoverride,tauoffsetoverride,$
;betacoeffshootoverride,betaexpshootoverride,tauoffsetshootoverride,$
;betaoversc,tauoversc,gammaexpoversc,$
;betashootoversc,taushootoversc,gammaexpshootoversc,$
;betacoeffoversc,betaexpoversc,tauoffsetoversc,$
;betacoeffshootoversc,betaexpshootoversc,tauoffsetshootoversc
;
iparsolve=iparsolve_in
;
; output file name for prints to file:
; 
if(ipix eq 0)then filoutnam='detselfcal0_'+tdtnam+iseq
if(ipix eq 1)then filoutnam='detselfcal1_'+tdtnam+iseq
if(ipix eq 2)then filoutnam='detselfcal2_'+tdtnam+iseq
if(ipix eq 3)then filoutnam='detselfcal3_'+tdtnam+iseq
if(ipix eq 4)then filoutnam='detselfcal4_'+tdtnam+iseq
if(ipix eq 5)then filoutnam='detselfcal5_'+tdtnam+iseq
if(ipix eq 6)then filoutnam='detselfcal6_'+tdtnam+iseq
if(ipix eq 7)then filoutnam='detselfcal7_'+tdtnam+iseq
if(ipix eq 8)then filoutnam='detselfcal8_'+tdtnam+iseq
;
filoutnam= !INTDIR + filoutnam 

print,'DETSELFCAL: writing results to file ',filoutnam
get_lun,iunit
openw,iunit,filoutnam
;
;save,/xdr,iparsolve,icalpt1,icalpt2,ipix,$
;betadef,taudef,gammaexpdef,betashootdef,taushootdef,gammaexpshootdef,$
;betacoeffdef,betaexpdef,tauoffsetdef,$
;betacoeffshootdef,betaexpshootdef,tauoffsetshootdef,$
;betaupsc,betadownsc,tauupsc,taudownsc,gammaexpupsc,gammaexpdownsc,$
;betashootupsc,betashootdownsc,taushootupsc,taushootdownsc,$
;gammaexpshootupsc,gammaexpshootdownsc,$
;betacoeffupsc,betacoeffdownsc,betaexpupsc,betaexpdownsc,tauoffsetupsc,$
;tauoffsetdownsc,betacoeffshootupsc,betacoeffshootdownsc,$
;betaexpshootupsc,betaexpshootdownsc,tauoffsetshootupsc,tauoffsetshootdownsc,$
;betaprec,tauprec,gammaexpprec,betashootprec,taushootprec,gammaexpshootprec,$
;betacoeffprec,betaexpprec,tauoffsetprec,$
;betacoeffshootprec,betaexpshootprec,tauoffsetshootprec,$
;signal0,signalshoot0,sillum0,$
;ngrid,from,to,nplat,nplateau,vigp,keyp,finep,pident,$
;keypoint,fpoint,itrans,ech,$
;eyt,ezt,msk,vig,t,signal,erms,imodel,isquare,islewmethod,ifinemethod,$
;niter,ndetinit,nplatinit,$
;nlookback,backminvthispix,backpredvthispix,$
;file='diagnostic_detselfcal.xdr'
;
savearray=array ; for TIMELINEFIGURE saves
dtimec=dtime    ; for TIMELINECOMPOSITEFIGURE saves
;
fitfcs=0.0
;
if(icalmethod eq 3)then begin ; suppress search in beta tau slow (done by fcs)
iparsolve(0)=0
iparsolve(1)=0
endif ; icalmethod eq 3
;
isolve=where(iparsolve eq 1,nisolve)
if(nisolve le 0)then begin
print,'DETSELFCAL: aborting - no parameters to be found for icalmethod = ',$
icalmethod
print,'... iparsolve_in,iparsolve = ',iparsolve_in,iparsolve
iparsolve=iparsolve_in
printf,iunit,'DETSELFCAL: aborting - no parameters to be found for icalmethod = ',$
icalmethod
printf,iunit,'... iparsolve_in,iparsolve = ',iparsolve_in,iparsolve
iparsolve=iparsolve_in
goto,c999
endif ; nisolve le 0
;
nsolmax=6 ; maximum dimensions of do loop nest in optimisation
;
if(nisolve gt nsolmax)then begin
print,'DETSELFCAL: aborting - can only solve for a maximum number '
print,'... of parameters of nsolmax = ',nsolmax
goto,c999
endif ; nisolve gt nsolmax
;
; output file name for storing data for TIMELINEFIGURE after each new
; minimum chi solution found:
; 
if(ipix eq 0)then tlfnam='timelinefigure0.xdr'
if(ipix eq 1)then tlfnam='timelinefigure1.xdr'
if(ipix eq 2)then tlfnam='timelinefigure2.xdr'
if(ipix eq 3)then tlfnam='timelinefigure3.xdr'
if(ipix eq 4)then tlfnam='timelinefigure4.xdr'
if(ipix eq 5)then tlfnam='timelinefigure5.xdr'
if(ipix eq 6)then tlfnam='timelinefigure6.xdr'
if(ipix eq 7)then tlfnam='timelinefigure7.xdr'
if(ipix eq 8)then tlfnam='timelinefigure8.xdr'
;
if(ipix eq 0)then compositenam='timelinecompositefigure0.xdr'
if(ipix eq 1)then compositenam='timelinecompositefigure1.xdr'
if(ipix eq 2)then compositenam='timelinecompositefigure2.xdr'
if(ipix eq 3)then compositenam='timelinecompositefigure3.xdr'
if(ipix eq 4)then compositenam='timelinecompositefigure4.xdr'
if(ipix eq 5)then compositenam='timelinecompositefigure5.xdr'
if(ipix eq 6)then compositenam='timelinecompositefigure6.xdr'
if(ipix eq 7)then compositenam='timelinecompositefigure7.xdr'
if(ipix eq 8)then compositenam='timelinecompositefigure8.xdr'

;
nitervar=25 ; maximum number of iterations for self cal (not to be confused
;             with niter for DRIFTCORR
;
; use IPARSOLVE to set up PARMIN PARMAX PARPREC PARSTART up to a maximum 
; dimension of (previously set) NSOLMAX
;
; Note that independent of model the optimisation is done with the 
; identifiers versus parameter in the following order:
; [beta,betacoeff,betaexp,tauoffset,tau,gammaexp,$
;  betashoot,betacoeffshoot,betaexpshoot,tauoffsetshoot,taushoot,gammaexpshoot]

parminall=[betadownsc,betacoeffdownsc,betaexpdownsc,$
tauoffsetdownsc,taudownsc,gammaexpdownsc,$
betashootdownsc,betacoeffshootdownsc,betaexpshootdownsc,$
tauoffsetshootdownsc,taushootdownsc,gammaexpshootdownsc]
;
parmaxall=[betaupsc,betacoeffupsc,betaexpupsc,$
tauoffsetupsc,tauupsc,gammaexpupsc,$
betashootupsc,betacoeffshootupsc,betaexpshootupsc,$
tauoffsetshootupsc,taushootupsc,gammaexpshootupsc]
;
parprecall=[betaprec,betacoeffprec,betaexpprec,$
tauoffsetprec,tauprec,gammaexpprec,$
betashootprec,betacoeffshootprec,betaexpshootprec,$
tauoffsetshootprec,taushootprec,gammaexpshootprec]
;
parstartall=[betadef,betacoeffdef,betaexpdef,$
tauoffsetdef,taudef,gammaexpdef,$
betashootdef,betacoeffshootdef,betaexpshootdef,$
tauoffsetshootdef,taushootdef,gammaexpshootdef]
;
parident=isolve
parmin=parminall(isolve)
parmax=parmaxall(isolve)
parprec=parprecall(isolve)
parstart=parstartall(isolve)
parmin_in=parmin
parmax_in=parmax
gammaexp_in=gammaexp ; sets up common block parameters
gammaexpshoot_in=gammaexpshoot
betashoot_in=betashoot
taushoot_in=taushoot
betacoeff_in=betacoeff
betaexp_in=betaexp
tauoffset_in=tauoffset
betacoeffshoot_in=betacoeffshoot
betaexpshoot_in=betaexpshoot
tauoffsetshoot_in=tauoffsetshoot
;
tplatback=0.0
tplatforward=0.0
signal0_in=signal0
signalshoot0_in=signalshoot0
sillum0_in=sillum0
iverbose=-1
;
;parmin=$
;[betadownsc,taudownsc,gammaexpdownsc,betashootdownsc,taushootdownsc,gammaexpshootdownsc]
;parmax=$
;[betaupsc,tauupsc,gammaexpupsc,betashootupsc,taushootupsc,gammaexpshootupsc]
;parmin_in=parmin
;parmax_in=parmax
;parstart=[betadef,taudef,gammaexpdef,betashootdef,taushootdef,gammaexpshootdef]
;parprec=$
;[betaprec,tauprec,gammaexpprec,betashootprec,taushootprec,gammaexpshootprec]
;
;gammaexp_in=gammaexp
;gammaexpshoot_in=gammaexpshoot
;betashoot_in=betashoot
;taushoot_in=taushoot
;tplatback=0.0
;tplatforward=0.0
;signal0_in=signal0
;signalshoot0_in=signalshoot0
;sillum0_in=sillum0
;iverbose=-1
;
dummy=iparsolve_in
if(icalmethod eq 3)then dummy(0:1)=1
iiprint=where(dummy eq 1,niiprint)
;
; prepare fcs cal optimisation for case icalmethod=3
;
if(icalmethod eq 3)then begin
fcsfraction=1.0 ; for ICALMETHOD=1 (fcs calibration) use only first fraction 
;                 FCSFRACTION of an fcs exposure to find beta tau 
imedfilter=1
iplotverbose=0
taudownscfcs=taudownsc
tauupscfcs=tauupsc
betaupscfcs=betaupsc
betadownscfcs=betadownsc
;
endif ; icalmethod eq 3
;
ipointstart=icalpt1
ipointstop=icalpt2
startendpoint,ipointstart,ipointstop,$
irasterstart,irasterstop,istartnoexpand,istopnoexpand,$
irasterstarte,irasterstope,istartexpand,istopexpand 
istopexpandfirst=irasterstope(ipointstart) ; last expanded sample of 
;        first s/c pointing, needed for determination of detector initial state
;        by DRIFTCORR with option NDETINIT GT 0
findramp,from,to,istartexpand,itest,iplat1
if(itest ne istartexpand)then begin
print,'DETSELFCAL: warning - fine point does not begin at start of plateau...'
print,'... istartexpand,itest,iplat1 = ',istartexpand,itest,iplat1
printf,iunit,'DETSELFCAL: warning - fine point does not begin at start of plateau...'
print,iunit,'... istartexpand,itest,iplat1 = ',istartexpand,itest,iplat1
endif ; itest ne istartexpand
;
neptin=n_elements(fpoint)
if(istopexpand lt neptin-1)then begin ; it is not the last point
findramp,from,to,istopexpand+1,itest,iplattest2
iplat2=iplattest2-1
if(itest ne istopexpand+1)then begin
print,'DETSELCAL: warning - fine pointing does not end at end of plateau...'
print,'... istopexpand,itest,iplat2 = ',istopexpand,itest,iplat2
printf,iunit,'DETSELCAL: warning - fine pointing does not end at end of plateau...'
printf,iunit,'... istopexpand,itest,iplat2 = ',istopexpand,itest,iplat2
endif ; itest ne istopexpand+1
endif ; istopexpand lt neptin-1
if(istopexpand eq neptin-1)then begin ; it is the last point
findramp,from,to,istopexpand,itest,iplat2
endif ; istopexpand eq neptin-1
;
if(istopexpandfirst lt neptin-1)then begin ; it is not the last point
findramp,from,to,istopexpandfirst+1,itest,iplattest2
iiplat2=iplattest2-1
if(itest ne istopexpandfirst+1)then begin
print,'DETSELFCAL: warning - fine pointing does not end at end of plateau...'
print,'... istopexpandfirst,itest,iiplat2 = ',istopexpandfirst,itest,iiplat2
printf,iunit,'DETSELFCAL: warning - fine pointing does not end at end of plateau...'
printf,iunit,'... istopexpandfirst,itest,iiplat2 = ',istopexpandfirst,itest,iiplat2
endif ; itest ne istopexpandfirst+1
endif ; istopexpandfirst lt neptin-1
if(istopexpandfirst eq neptin-1)then begin ; it is the last point
findramp,from,to,istopexpandfirst,itest,iiplat2
endif ; istopexpandfirst eq neptin-1
;
print,'DETSELFCAL: ipix,ipointstart,ipointstop = ',$
byte(ipix),ipointstart,ipointstop
print,'...         iplat1,iplat2,istartexpand,istopexpandfirst,istopexpand ='
print,iplat1,iplat2,istartexpand,istopexpandfirst,istopexpand
print,'betadef,betacoeffdef,betaexpdef = ',betadef,betacoeffdef,betaexpdef
print,'tauoffsetdef,taudef,gammaexpdef = ',tauoffsetdef,taudef,gammaexpdef
print,'beta,betacoeff,betaexp (shoot)  = ',$
betashootdef,betacoeffshootdef,betaexpshootdef
print,'tauoffset,tau,gammaexp (shoot)  = ',$
tauoffsetshootdef,taushootdef,gammaexpshootdef
if(iparsolve(0) eq 1)then $
print,'betadown,betaup,prec          = ',betadownsc,betaupsc,betaprec
if(iparsolve(1) eq 1)then $
print,'betacoeffdown,betacoeffup,prec= ',betacoeffdownsc,betacoeffupsc,$
betacoeffprec
if(iparsolve(2) eq 1)then $
print,'betaexpdown,betaexpup,prec    = ',betaexpdownsc,betaexpupsc,$
betaexpprec
if(iparsolve(3) eq 1)then $
print,'tauoffsetdown,tauoffsetup,prec= ',tauoffsetdownsc,tauoffsetupsc,$
tauoffsetprec
if(iparsolve(4) eq 1)then $
print,'taudown,tauup,prec            = ',taudownsc,tauupsc,tauprec
if(iparsolve(5) eq 1)then $
print,'gammaexpdown,gammaexpup,prec  = ',$
gammaexpdownsc,gammaexpupsc,gammaexpprec
if(iparsolve(6) eq 1)then $
print,'betashootdown,betashootup,prec= ',$
betashootdownsc,betashootupsc,betashootprec
if(iparsolve(7) eq 1)then $
print,'betacoeffshootdown,betacoeffshootup,prec= ',$
betacoeffshootdownsc,betacoeffshootupsc,betacoeffshootprec
if(iparsolve(8) eq 1)then print,$
'betaexpshootdown,betaexpshootup,prec=',betaexpshootdownsc,betaexpshootupsc,$
betaexpshootprec
if(iparsolve(9) eq 1)then $
print,'tauoffsetshootdown,tauoffsetshootup,prec=',$
tauoffsetshootdownsc,tauoffsetshootupsc,tauoffsetshootprec
if(iparsolve(10) eq 1)then $
print,'taushootdown,taushootup,prec  = ',$
taushootdownsc,taushootupsc,taushootprec
if(iparsolve(11) eq 1)then $
print,'gammaexpdown,gammaexpup,prec (sh)= ',$
gammaexpshootdownsc,gammaexpshootupsc,gammaexpshootprec
;
printf,iunit,'DETSELFCAL: ipix,ipointstart,ipointstop = ',$
byte(ipix),ipointstart,ipointstop
printf,iunit,'...         iplat1,iplat2,istartexpand,istopexpandfirst,istopexpand ='
printf,iunit,iplat1,iplat2,istartexpand,istopexpandfirst,istopexpand
printf,iunit,$
'betadef,betacoeffdef,betaexpdef = ',betadef,betacoeffdef,betaexpdef
printf,iunit,$
'tauoffsetdef,taudef,gammaexpdef = ',tauoffsetdef,taudef,gammaexpdef
printf,iunit,$
'betashootdef,betacoeffshootdef,betaexpshootdef = ',$
betashootdef,betacoeffshootdef,betaexpshootdef
printf,iunit,$
'tauoffsetshootdef,taushootdef,gammaexpshootdef = ',$
tauoffsetshootdef,taushootdef,gammaexpshootdef
;
;printf,iunit,'betadef,taudef,gammaexpdef = ',betadef,taudef,gammaexpdef
;printf,iunit,'betashootdef,taushootdef,gammaexpshootdef = ',$
;betashootdef,taushootdef,gammaexpshootdef
;
if(iparsolve(0) eq 1)then $
printf,iunit,'betadownsc,betaupsc          = ',betadownsc,betaupsc
if(iparsolve(1) eq 1)then $
printf,iunit,'betacoeffdownsc,betacoeffupsc   = ',betacoeffdownsc,betacoeffupsc
if(iparsolve(2) eq 1)then $
printf,iunit,'betaexpdownsc,betaexpupsc       = ',betaexpdownsc,betaexpupsc
if(iparsolve(3) eq 1)then $
printf,iunit,'tauoffsetdownsc,tauoffsetupsc   = ',tauoffsetdownsc,tauoffsetupsc
if(iparsolve(4) eq 1)then $
printf,iunit,'taudownsc,tauupsc            = ',taudownsc,tauupsc
if(iparsolve(5) eq 1)then $
printf,iunit,'gammaexpdownsc,gammaexpupsc  = ',$
gammaexpdownsc,gammaexpupsc
if(iparsolve(6) eq 1)then $
printf,iunit,'betashootdownsc,betashootupsc= ',$
betashootdownsc,betashootupsc
if(iparsolve(7) eq 1)then $
printf,iunit,'betacoeffshootdownsc,betacoeffshootupsc= ',$
betacoeffshootdownsc,betacoeffshootupsc
if(iparsolve(8) eq 1)then printf,iunit,$
'betaexpshootdownsc,betaexpshootupsc=',betaexpshootdownsc,betaexpshootupsc
if(iparsolve(9) eq 1)then $
printf,iunit,'tauoffsetshootdownsc,tauoffsetshootupsc=',$
tauoffsetshootdownsc,tauoffsetshootupsc
if(iparsolve(10) eq 1)then $
printf,iunit,'taushootdownsc,taushootupsc  = ',$
taushootdownsc,taushootupsc
if(iparsolve(11) eq 1)then $
printf,iunit,'gammaexpdownsc,gammaexpupsc (sh)= ',$
gammaexpshootdownsc,gammaexpshootupsc
;
;if(iparsolve(0) eq 1)then printf,iunit,'betadownsc,betaupsc          = ',betadownsc,betaupsc
;if(iparsolve(1) eq 1)then printf,iunit,'taudownsc,tauupsc            = ',taudownsc,tauupsc
;if(iparsolve(2) eq 1)then printf,iunit,'gammaexpdownsc,gammaexpupsc  = ',$
;gammaexpdownsc,gammaexpupsc
;if(iparsolve(3) eq 1)then printf,iunit,'betashootdownsc,betashootupsc= ',$
;betashootdownsc,betashootupsc
;if(iparsolve(4) eq 1)then printf,iunit,'taushootdownsc,taushootupsc  = ',$
;taushootdownsc,taushootupsc
;if(iparsolve(5) eq 1)then printf,iunit,'gammaexpdownsc,gammaexpupsc (sh)= ',$
;gammaexpshootdownsc,gammaexpshootupsc
;
; prepare composite sweep if self calibration to be performed on this
;
if(icompositecorr eq 1)then begin
print,'DETSELFCAL - running with ICOMPOSITECORR = 1'
printf,iunit,'DETSELFCAL - running with ICOMPOSITECORR = 1'
if(icalpt1 ne icalpt2)then begin
print,'DETSELFCAL - aborting - the option ICOMPOSITECORR=1 can only be'
print,'                        effected on a single pointing'
printf,iunit,'DETSELFCAL - aborting - the option ICOMPOSITECORR=1 can only be'
printf,iunit,'                        effected on a single pointing'
goto, c999
endif ; icalpt1 ne icalpt2
;
if(compositeweight(1) ne 0.0)then begin
if(psflux le 0.0 or backpredvthispix eq 0.0)then begin
print,'DETSELFCAL - aborting - the option ICOMPOSITECORR=1 can only be used'
print,'in conjunction with an illumination constraint when a source flux (Jy)'
print,'and background brightness (MJy/sterad) is given'
printf,iunit,$
'DETSELFCAL - aborting - the option ICOMPOSITECORR=1 can only be used'
printf,iunit,$
'in conjunction with an illumination constraint when a source flux (Jy)'
printf,iunit,'and background brightness (MJy/sterad) is given'
goto,c999
endif ; psflux le 0.0 or backpredvthispix eq 0.0
;
; create beam map in pixel considered in V/s for given PSFLUX (Jy)
; and BACKPREDVTHISPIX (V/s with no non-linearity correction), taking into 
; account non-linearity correction.
;
;vsmap=(backpred/psconv1(ipix)) + (psflux*psmap(ipix,*,*))
vsmap=fltarr(n_elements(psmap(0,*,0)),n_elements(psmap(0,0,*)))
;vsmap(*,*)=backpredvthispix + (psflux*psmap(ipix,*,*))
;
; properly take into account signal non-linearity in converting to V/s ERD
; (which have not been corrected for signal non-linearity):
;
vsmap(*,*)=backpred+(psconv1(ipix)*psflux*psmap(ipix,*,*)) ; in MJy/sterad
dummy1=fltarr(nygrid*nzgrid)
dummy1(*)=vsmap(*,*)
mjtovs,ipix,idefcal,dummy1,dummy2
vsmap(*,*)=dummy2 ; in V/s
;
endif ; compositeweight(1) ne 0.0
;
createcomposite,istartexpand,istopexpand,from,to,keyp,vigp,nplateau,$
t,signal,erms,itrans,msk,keypoint,ech,finep,pident,eyt,ezt,fpoint,$
vig,vigc,finepc,pidentc,eytc,eztc,fpointc,nplatc,nplateauc,$
signalc,tc,ermsc,itransc,echc,mskc,inrampidentc,$
keypointc,istartexpandc,istopexpandc,toc,fromc,vigpc,keypc,nc
;
if(compositeweight(1) ne 0.0)then begin ; find target illuminations 
;                                         from simulation on composite sweep
help,keypointc
ktoyz,keypointc,iy,iz
;
if(max(iz) ne min(iz))then begin
print,'DETSELFCAL - aborting: error in determination of simulated illumination'
printf,iunit,$
'DETSELFCAL - aborting - error in determination ofsimulated illumination'
goto, c999
endif ; max(iz) ne min(iz)
;
illsim=signalc ; initialisation
illsim(*)=vigc(*)*vsmap(iy,iz(0))
;
endif ; compositeweight(1) ne 0.0
;
ident=-2
if(ident ge 0)then ii=where(mskc eq 0 and inrampidentc eq ident,nii)
if(ident eq -1)then ii=where(mskc eq 0,nii)
if(ident le -2)then ii=where(mskc eq 0 and nc gt max(nc)/2,nii) ; only use
;                                            points with good statistics
;
;save,/xdr,istartexpand,istopexpand,from,to,keyp,vigp,nplateau,$
;t,signal,erms,itrans,msk,keypoint,ech,finep,pident,eyt,ezt,fpoint,$
;vig,vigc,finepc,pidentc,eytc,eztc,fpointc,nplatc,nplateauc,$
;signalc,tc,ermsc,itransc,echc,mskc,inrampidentc,$
;keypointc,istartexpandc,istopexpandc,toc,fromc,vigpc,keypc,nc,$
;file='createcomposite_diag.xdr'
;
iicalc=ii
mskc(*)=1
mskc(ii)=0
;
endif ; icomposItecorr eq 1
;
; input
;  PARMIN,PARMAX (arrays dimension number of variables): search range
;    for value of parameters beta tau gammaexp
;  PARSTART (arrays dimension number of variables): best estimate for
;    value of parameters beta tau gammaexp
;  PARPREC (arrays dimension number of variables): precision for 
;    solution for parameters beta tau gammaexp. Set to actual fineness
;    of search on output
;  IPARSOLVE (integer array dimension number of variables): set element to 1 
;    for variables to be varied in optimisation; set element to 0 for variables
;    not to be varied (these variables are fixed with the value of the
;    corresponding element of PARSTART during the optimisation).
;  NITER maximum number of iterations
;
; output
;  PAR (array dimension number of variables): best fit values. Variables not
;    searched for have the corresponding element of PAR set to the value in 
;    PARSTART.
;  PARPREC (arrays dimension number of variables): precision for 
;    solution for parameters beta tau gammaexp. Set to actual fineness
;    of search on output
;  CHIMIN (single real) minimum vaalue of chi-squared for fit
;
;
;npar=n_elements(parstart)
npar=nsolmax ; should be 6 (only first nisolve are optimised)
par=dblarr(npar)
iparsolve=lonarr(nsolmax)
iparsolve(0:nisolve-1)=1
;
dummy=fltarr(nsolmax)
dummy(0:nisolve-1)=parprec(*)
parprec=dummy
;
dummy=fltarr(nsolmax)
dummy(0:nisolve-1)=parmin(*)
parmin=dummy
;
dummy=fltarr(nsolmax)
dummy(0:nisolve-1)=parmax(*)
parmax=dummy
;
dummy=fltarr(nsolmax)
dummy(0:nisolve-1)=parstart(*)
parstart=dummy
;
; internal constants controlling trade off between speed, precision and 
; robustness of fit
;
ncut=lonarr(npar)
ncut(*)=3 ; must be odd and at least 3, for parameters included in optimisation
          ; (ie with IPARSOLVE=1). For parameters not included in optimisation
;           (ie with IPARSOLVE=0) the corresponding element of NCUT should be 
;           set to 1. 
;
isol=-1 ; counter for trial solutions
iicut0=where(iparsolve le 0,niicut0)
iicut1=where(iparsolve gt 0,niicut1)
nmaxtrial=1
for i=0,niicut1-1 do nmaxtrial=nmaxtrial*ncut(iicut1(i))
nmaxtrial=nmaxtrial*(nitervar+1)
trialsol=fltarr(nmaxtrial,niicut1)
print,'DETSELFCAL: maximum number of trials to be calculated = ',nmaxtrial
if(niicut0 gt 0)then ncut(iicut0)=1
icut=lonarr(npar)
reduce=dblarr(npar)
reduce(*)=1.5 ; must be in range > 1.0 (slow  to 2.0 (fast)
;xncut=dblarr(npar)
xncut=float(ncut)
top=parmax ; array dimension npar
bot=parmin
dcut=fltarr(npar)
dcut(iicut1)=(top(iicut1)-bot(iicut1))/(xncut(iicut1)-1.0) ; array dim. ncut
if(niicut0 gt 0)then $
dcut(iicut0)=(top(iicut0)-bot(iicut0))/(max(xncut(iicut1))-1.0)
partrial=dblarr(npar) ; one trial value for each parameter
;
for ipar=0,npar-1 do begin
;
if(ncut(ipar) eq 1)then begin
;
bot(ipar)=parstart(ipar)
top(ipar)=bot(ipar)
endif ; ncut(ipar) eq 1
;
partrial(ipar)=bot(ipar)
;
;print,'ipar,ncut(ipar),bot(ipar),top(ipar),dcut(ipar),partrial(ipar) = '
;print,ipar,ncut(ipar),bot(ipar),top(ipar),dcut(ipar),partrial(ipar)
;
; diagnostic prior to loop
;print,'ipar,ncut(ipar),dcut(ipar),bot(ipar),top(ipar) = '
;print,ipar,ncut(ipar),dcut(ipar),bot(ipar),top(ipar)
;
endfor ; ipar=0,npar-1
;
; first trial to initialise par,chimin on best input estimate of parameters
; from betadef etc
;
;gammaexp=partrial(2)
;betashoot=partrial(3)
;taushoot=partrial(4)
;gammaexpshoot=partrial(5)
;
betawk=betadef
betacoeff=betacoeffdef
betaexp=betaexpdef
tauoffset=tauoffsetdef
tauwk=taudef
gammaexp=gammaexpdef
betashoot=betashootdef
betacoeffshoot=betacoeffshootdef
betaexpshoot=betaexpshootdef
tauoffsetshoot=tauoffsetshootdef
taushoot=taushootdef
gammaexpshoot=gammaexpshootdef
;
for i=0,nisolve-1 do begin
;
if(parident(i) eq 0)then partrial(i)=betadef
if(parident(i) eq 1)then partrial(i)=betacoeffdef
if(parident(i) eq 2)then partrial(i)=betaexpdef
if(parident(i) eq 3)then partrial(i)=tauoffsetdef
if(parident(i) eq 4)then partrial(i)=taudef
if(parident(i) eq 5)then partrial(i)=gammaexpdef
if(parident(i) eq 6)then partrial(i)=betashootdef
if(parident(i) eq 7)then partrial(i)=betacoeffshootdef
if(parident(i) eq 8)then partrial(i)=betaexpshootdef
if(parident(i) eq 9)then partrial(i)=tauoffsetshootdef
if(parident(i) eq 10)then partrial(i)=taushootdef
if(parident(i) eq 11)then partrial(i)=gammaexpshootdef
;
if(parident(i) eq 0)then betawk=partrial(i)
if(parident(i) eq 1)then betacoeff=partrial(i)
if(parident(i) eq 2)then betaexp=partrial(i)
if(parident(i) eq 3)then tauoffset=partrial(i)
if(parident(i) eq 4)then tauwk=partrial(i)
if(parident(i) eq 5)then gammaexp=partrial(i)
if(parident(i) eq 6)then betashoot=partrial(i)
if(parident(i) eq 7)then betacoeffshoot=partrial(i)
if(parident(i) eq 8)then betaexpshoot=partrial(i)
if(parident(i) eq 9)then tauoffsetshoot=partrial(i)
if(parident(i) eq 10)then taushoot=partrial(i)
if(parident(i) eq 11)then gammaexpshoot=partrial(i)
;
endfor ; i=0,nisolve-1
;
;gammaexp=gammaexpdef
;betashoot=betashootdef
;taushoot=taushootdef
;gammaexpshoot=gammaexpshootdef
;
if(icalmethod eq 3)then begin ; fcs optimisation of tau and beta
;
if(imodel gt 2)then begin
print,'DELSELFCAL: warning - it is inadvisable to optimise, beta tau with FCS'
print,'... within DETSELFCAL with imodel = 3 or more as the jump and '
print,'... time constants are defined by functions of several parameters '  
endif ; imodel gt 2
;
ibefore=1
findillumbeforefcs,ipix,ibefore,bestsky,nbestsky,illumsky,ifound,0,0 ; n. verb.
illumskyprevfilter=illumsky
betabefore=betadef
taubefore=taudef
;
findbetataufcs,[ipix],imodel,isquare,ibefore,illumsky,illumskyprevfilter,$
betadownscfcs,betaupscfcs,taudownscfcs,tauupscfcs,betabefore,taubefore,$
sillumoutbefore,sillumbeforeraster,sillumshootbeforeraster,fcsfraction,$
imedfilter,fitresultoutbefore,iplotverbose
;
betafter=betadef
tauafter=taudef
ibefore=0
findillumbeforefcs,ipix,ibefore,bestsky,nbestsky,illumsky,ifound,0,0 ; n verb.
illumskyprevfilter=illumsky 
findbetataufcs,[ipix],imodel,isquare,ibefore,illumsky,illumskyprevfilter,$
betadownscfcs,betaupscfcs,taudownscfcs,tauupscfcs,betafter,tauafter,$
sillumoutafter,sillumbeforeraster,sillumshootbeforeraster,fcsfraction,$
imedfilter,fitresultoutafter,iplotverbose
;
betawk=(betabefore+betafter)/2.0
tauwk=(taubefore+tauafter)/2.0
betawk=betawk(0)
tauwk=tauwk(0)
fitfcs=(fitresultoutbefore(0)+fitresultoutafter(0))/2.0
;
;partrial(0)=betawk(0)
;partrial(1)=tauwk(0)
;
endif ; icalmethod eq 3
;
signal0=signal0_in
signalshoot0=signalshoot0_in
sillum0=sillum0_in
;
; for imodel =3 only find solution for trial set of parameters if
; constraints satisfied
if(imodel eq 3)then begin
icongood=1
constrain_model3,betawk(0),tauwk(0),icongood
if(icongood eq 0)then begin
print,'DETSELFCAL *** warning *** initial solution found from parameter ...'
print,'       ... set for which derived parameters do not satisfy constraints'
endif ; icongood eq 0
endif ; imodel eq 3
;
sillchi=0.0
if(icompositecorr ne 1)then begin
driftcorr,betawk(0),tauwk(0),signal0,signalshoot0,sillum0,ngrid,$
from,to,nplat,nplateau,vigp,keyp,finep,pident,$
keypoint,fpoint,itrans,ech,$
eyt,ezt,msk,vig,t,signal,erms,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfit,modelfitshoot,modelfitslow,respcorr,maskout,niter,$
istartexpand,istopexpand,istopexpandfirst,iplat1,iplat2,ndetinit,nplatinit,$
ipix,tplatback,tplatforward,nlookback,backminvthispix,backpredvthispix,ierr,$
iverbose,chi
endif ; icompositecorr ne 1
;
if(icompositecorr eq 1)then begin
;
compositedriftcorr,betawk(0),tauwk(0),signal0,signalshoot0,sillum0,ngrid,$
fromc,toc,nplatc,nplateauc,vigpc,keypc,finepc,pidentc,$
keypointc,fpointc,itransc,echc,$
eytc,eztc,mskc,vigc,tc,signalc,ermsc,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfitc,respcorrc,maskoutc,istartexpandc,istopexpandc,$
ipix,backminvthispix,backpredvthispix,ierr,iverbose,chi
;
; component of chi-squared from difference between simulated illumination 
; and DRIFTCORR result:
; 
if(compositeweight(1) ne 0.0)then begin
compositeillchi,mskc,ermsc,respcorrc,modelfitc,isquare,illchi
sillchi=illchi(0)
endif ; compositeweight(1) ne 0.0
;
endif ; icompositecorr eq 1
;
chisky=chi(0)
if(icompositecorr eq 1 and compositeweight(1) ne 0.0)then begin
chisky=chisky*compositeweight(0)
sillchi=sillchi*compositeweight(1)
fitfcs=fitfcs*compositeweight(2)
endif ; icompositecorr eq 1 and compositeweight(1) ne 0.0
chi=chisky+fitfcs+sillchi
;
for i=0,nisolve-1 do begin
;
;if(parident(i) eq 0)then par(i)=beta
if(parident(i) eq 0)then par(i)=betawk
if(parident(i) eq 1)then par(i)=betacoeff
if(parident(i) eq 2)then par(i)=betaexp
if(parident(i) eq 3)then par(i)=tauoffset
;if(parident(i) eq 4)then par(i)=tau
if(parident(i) eq 4)then par(i)=tauwk
if(parident(i) eq 5)then par(i)=gammaexp
if(parident(i) eq 6)then par(i)=betashoot
if(parident(i) eq 7)then par(i)=betacoeffshoot
if(parident(i) eq 8)then par(i)=betaexpshoot
if(parident(i) eq 9)then par(i)=tauoffsetshoot
if(parident(i) eq 10)then par(i)=taushoot
if(parident(i) eq 11)then par(i)=gammaexpshoot
;
endfor ; i=0,nisolve-1
;
;par(*)=[partrial(0),partrial(1),gammaexpdef,betashootdef,taushootdef,$
;gammaexpshootdef]
;
;chimin=chisky+fitfcs+sillchi
chimin=chi
isol=isol+1
if(niicut1 gt 1)then trialsol(isol,*)=par(iicut1)
if(niicut1 le 1)then trialsol(isol)=par(iicut1)
;print,'*** par:',float(par(0:nisolve-1))
;print,'chisky,fitfcs,chimin:',[float(chisky),float(fitfcs),float(chisky)]
printf,iunit,'*** par:',float(par(0:nisolve-1))
printf,iunit,'chisky,fitfcs,sillchi,chimin:',$
[float(chisky),float(fitfcs),float(sillchi),float(chimin)]
;
parall=parstartall
parall(parident)=par(0:nisolve-1)
;
; plot first solution and save data
;
;
if(icompositecorr ne 1)then begin
modelfitbest=modelfit
respcorrbest=respcorr
maskoutbest=maskout
maskinbest=msk
skypasssav=skypass
save,/xdr,time,fpoint,msk,itrans,modelfit,respcorr,signal,maskout,ech,$
savearray,skypasssav,file=!INTDIR+tlfnam
;
; diagnostic for ipix to window ipix+1 made before zero levels and low values 
; restored in S
timelinefigure,ipix+1,ipointstart,ipointstop,'fine',ipix,'' 
endif ; icompositecorr ne 1
;
if(icompositecorr eq 1)then begin
modelfitbest=modelfitc
respcorrbest=respcorrc
maskoutbest=maskoutc
maskinbest=mskc
save,/xdr,mskc,inrampidentc,iicalc,signalc,tc,savearray,echc,dtimec,toc,fromc,$
modelfitc,respcorrc,file=!INTDIR+compositenam
timelinecomposite,0,ipix,'' ; to window 0
endif ; icompositecorr eq 1
;
iter=0 ; counter of number of iterations
;
c100:
;
; example of six dimensions
;
for i0=0,ncut(0)-1 do begin
icut(0)=i0
partrial(0)=bot(0)+dcut(0)*float(icut(0))
for i1=0,ncut(1)-1 do begin
icut(1)=i1
partrial(1)=bot(1)+dcut(1)*float(icut(1))
for i2=0,ncut(2)-1 do begin
icut(2)=i2
partrial(2)=bot(2)+dcut(2)*float(icut(2))
for i3=0,ncut(3)-1 do begin
icut(3)=i3
partrial(3)=bot(3)+dcut(3)*float(icut(3))
for i4=0,ncut(4)-1 do begin
icut(4)=i4
partrial(4)=bot(4)+dcut(4)*float(icut(4))
for i5=0,ncut(5)-1 do begin
icut(5)=i5
partrial(5)=bot(5)+dcut(5)*float(icut(5))
;
for i=0,nisolve-1 do begin
;
if(parident(i) eq 0)then betawk=partrial(i)
if(parident(i) eq 1)then betacoeff=partrial(i)
if(parident(i) eq 2)then betaexp=partrial(i)
if(parident(i) eq 3)then tauoffset=partrial(i)
if(parident(i) eq 4)then tauwk=partrial(i)
if(parident(i) eq 5)then gammaexp=partrial(i)
if(parident(i) eq 6)then betashoot=partrial(i)
if(parident(i) eq 7)then betacoeffshoot=partrial(i)
if(parident(i) eq 8)then betaexpshoot=partrial(i)
if(parident(i) eq 9)then tauoffsetshoot=partrial(i)
if(parident(i) eq 10)then taushoot=partrial(i)
if(parident(i) eq 11)then gammaexpshoot=partrial(i)
;
endfor ; i=0,nisolve-1
;
;gammaexp=partrial(2)
;betashoot=partrial(3)
;taushoot=partrial(4)
;gammaexpshoot=partrial(5)
;
if(icalmethod eq 3)then begin ; fcs optimisation of tau and beta
ibefore=1
findillumbeforefcs,ipix,ibefore,bestsky,nbestsky,illumsky,ifound,0,0 ; n. verb.
illumskyprevfilter=illumsky
betabefore=betadef
taubefore=taudef
;
findbetataufcs,[ipix],imodel,isquare,ibefore,illumsky,illumskyprevfilter,$
betadownscfcs,betaupscfcs,taudownscfcs,tauupscfcs,betabefore,taubefore,$
sillumoutbefore,sillumbeforeraster,sillumshootbeforeraster,fcsfraction,$
imedfilter,fitresultoutbefore,iplotverbose
;
betafter=betadef
tauafter=taudef
ibefore=0
findillumbeforefcs,ipix,ibefore,bestsky,nbestsky,illumsky,ifound,0,0 ; n verb.
illumskyprevfilter=illumsky 
findbetataufcs,[ipix],imodel,isquare,ibefore,illumsky,illumskyprevfilter,$
betadownscfcs,betaupscfcs,taudownscfcs,tauupscfcs,betafter,tauafter,$
sillumoutafter,sillumbeforeraster,sillumshootbeforeraster,fcsfraction,$
imedfilter,fitresultoutafter,iplotverbose
;
fitfcs=(fitresultoutbefore(0)+fitresultoutafter(0))/2.0
betawk=(betabefore+betafter)/2.0
tauwk=(taubefore+tauafter)/2.0
;partrial(0)=betawk(0)
;partrial(1)=tauwk(0)
;
endif ; icalmethod eq 3
;
signal0=signal0_in
signalshoot0=signalshoot0_in
sillum0=sillum0_in
;
; check whether we have solve for this combination before. Only run
; DRIFTCORR if not:
;
nsol=isol+1
;help,trialsol
for i=0,nsol-1 do begin
ncount=0
for ii=0,niicut1-1 do begin
ipar=iicut1(ii)
;print,'i,ipar = ',i,ipar
if(niicut1 gt 1)then begin
if(trialsol(i,ii) eq partrial(ipar))then ncount=ncount+1
endif ; niicut1 gt 1
if(niicut1 le 1)then begin
if(trialsol(i) eq partrial(ipar))then ncount=ncount+1
endif ; niicut1 gt 1
endfor ; ii=0,niicut1-1
if(ncount eq niicut1)then goto, c845 ; bypass this solution since we have
;                                     already done it
endfor ; i=0,nsol-1
;
; avoid parameter combination not satisfying constraints
if(imodel eq 3)then begin
icongood=1
constrain_model3,betawk(0),tauwk(0),icongood
if(icongood eq 0)then begin
;print,'DETSELFCAL *** warning *** parameter ...'
;print,'       ... set for which derived parameters do not satisfy constraints'
;print,'parvar:',float(partrial(0:nisolve-1))
goto, c845
endif ; icongood eq 0
endif ; imodel eq 3
;
sillchi=0.0
if(icompositecorr ne 1)then begin
driftcorr,betawk(0),tauwk(0),signal0,signalshoot0,sillum0,ngrid,$
from,to,nplat,nplateau,vigp,keyp,finep,pident,$
keypoint,fpoint,itrans,ech,$
eyt,ezt,msk,vig,t,signal,erms,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfit,modelfitshoot,modelfitslow,respcorr,maskout,niter,$
istartexpand,istopexpand,istopexpandfirst,iplat1,iplat2,ndetinit,nplatinit,$
ipix,tplatback,tplatforward,nlookback,backminvthispix,backpredvthispix,ierr,$
iverbose,chi
endif ; icompositecorr ne 1
;
if(icompositecorr eq 1)then begin
compositedriftcorr,betawk(0),tauwk(0),signal0,signalshoot0,sillum0,ngrid,$
fromc,toc,nplatc,nplateauc,vigpc,keypc,finepc,pidentc,$
keypointc,fpointc,itransc,echc,$
eytc,eztc,mskc,vigc,tc,signalc,ermsc,imodel,isquare,islewmethod,ifinemethod,$
fitresult,modelfitc,respcorrc,maskoutc,istartexpandc,istopexpandc,$
ipix,backminvthispix,backpredvthispix,ierr,iverbose,chi
;
; component of chi-squared from difference between simulated illumination 
; and DRIFTCORR result:
; 
if(compositeweight(1) ne 0.0)then begin
compositeillchi,mskc,ermsc,respcorrc,modelfitc,isquare,illchi
sillchi=illchi(0)
endif ; compositeweight(1) ne 0.0
;
endif ; icompositecorr eq 1
;
chisky=chi(0)
;
if(icompositecorr eq 1 and compositeweight(1) ne 0)then begin
chisky=chisky*compositeweight(0)
sillchi=sillchi*compositeweight(1)
fitfcs=fitfcs*compositeweight(2)
endif ; icompositecorr eq 1 and compositeweight(1) ne 0
;
chi=chisky+fitfcs+sillchi
isol=isol+1
;if(niicut1 gt 1)then trialsol(isol,*)=par(iicut1)
;if(niicut1 le 1)then trialsol(isol)=par(iicut1)
if(niicut1 gt 1)then trialsol(isol,*)=partrial(0:nisolve-1)
if(niicut1 le 1)then trialsol(isol)=partrial(*)
;
;print,'parvar:',float(partrial(iiprint))
;print,'parvar:',float(partrial(0:nisolve-1))
;print,'chisky,fitfcs,chi:',[float(chisky),float(fitfcs),float(chi)]
printf,iunit,'parvar:',float(partrial(0:nisolve-1))
printf,iunit,'chisky,fitfcs,sillchi,chi:',$
[float(chisky),float(fitfcs),float(sillchi),float(chi)]
;
if(chi le chimin)then begin ; found new minimum
chimin=chi ; single value
par=partrial ; array
icutmin=icut ; array
parall=parstartall
parall(parident)=partrial(0:nisolve-1)
print,'parvar:',float(partrial(0:nisolve-1))
;print,'chisky,fitfcs,sillchi,chi:',$
;[float(chisky),float(fitfcs),float(sillchi),float(chi)]
print,'*** parall:',float(parall)
print,'chisky,fitfcs,sillchi,chimin:',$
[float(chisky),float(fitfcs),float(sillchi),float(chimin)]
printf,iunit,'*** parall:',float(parall)
printf,iunit,'chisky,fitfcs,sillchi,chimin:',$
[float(chisky),float(fitfcs),float(sillchi),float(chimin)]
;
; plot latest solution for minimum and save data
;
if(icompositecorr ne 1)then begin
modelfitbest=modelfit
respcorrbest=respcorr
maskoutbest=maskout
maskinbest=msk
skypasssav=skypass
save,/xdr,time,fpoint,msk,itrans,modelfit,respcorr,signal,maskout,ech,$
savearray,skypasssav,file=!INTDIR+tlfnam
endif ; icompositecorr ne 1
;
if(icalmethod eq 3)then begin ; plot fcs solution with text too
;
ibefore=1
findillumbeforefcs,ipix,ibefore,bestsky,nbestsky,illumsky,ifound,0,0 ; n. verb.
illumskyprevfilter=illumsky
betabefore=betadef
taubefore=taudef
findbetataufcs,[ipix],imodel,isquare,ibefore,illumsky,illumskyprevfilter,$
betadownscfcs,betaupscfcs,taudownscfcs,tauupscfcs,betabefore,taubefore,$
sillumoutbefore,sillumbeforeraster,sillumshootbeforeraster,fcsfraction,$
imedfilter,fitresultoutbefore,1
;
ibefore=0
findillumbeforefcs,ipix,ibefore,bestsky,nbestsky,illumsky,ifound,0,0 ; n. verb.
illumskyprevfilter=illumsky
betafter=betadef
tauafter=taudef
findbetataufcs,[ipix],imodel,isquare,ibefore,illumsky,illumskyprevfilter,$
betadownscfcs,betaupscfcs,taudownscfcs,tauupscfcs,betafter,tauafter,$
sillumoutafter,sillumbeforeraster,sillumshootbeforeraster,fcsfraction,$
imedfilter,fitresultoutafter,1
;
endif ; icalmethod eq 3
;
; diagnostic for ipix to window ipix+1 made before zero levels and low values 
; restored in S
if(icompositecorr ne 1)then $
timelinefigure,ipix+1,ipointstart,ipointstop,'fine',ipix,'' 
;
if(icompositecorr eq 1)then begin
modelfitbest=modelfitc
respcorrbest=respcorrc
maskoutbest=maskoutc
maskinbest=mskc
save,/xdr,mskc,inrampidentc,iicalc,signalc,tc,savearray,echc,dtimec,toc,fromc,$
modelfitc,respcorrc,file=!INTDIR+compositenam
timelinecomposite,0,ipix,'' ; to window 0
endif ; icompositecorr eq 1
;
endif ; chi lt chimin
;
c845:
;
endfor ; i5=0,ncut(5)-1
endfor ; i4=0,ncut(4)-1
endfor ; i3=0,ncut(3)-1
endfor ; i2=0,ncut(2)-1
endfor ; i1=0,ncut(1)-1
endfor ; i0=0,ncut(0)-1
;
; update search ranges bot top dcut ncut xncut
; 
for ipar=0,npar-1 do begin
;
if(ncut(ipar) gt 1)then begin
;
d=top(ipar)-bot(ipar)
d=d/reduce(ipar)
d2=d/2.0
bot(ipar)=par(ipar)-d2 ; par is array with current best solution
top(ipar)=par(ipar)+d2
bottmp=bot(ipar)
toptmp=top(ipar)
if(bot(ipar) lt parmin(ipar))then begin
bottmp=parmin(ipar)
toptmp=bottmp+d
endif ; bot(ipar)
if(top(ipar) gt parmax(ipar))then begin
toptmp=parmax(ipar)
bottmp=toptmp-d
endif ; top(ipar)
bot(ipar)=bottmp
top(ipar)=toptmp
dcut(ipar)=(top(ipar)-bot(ipar))/(xncut(ipar)-1.0)
;
; if requested precision has been attained for ipar suppress further search 
; in var(ipar):
;
if(dcut(ipar) le parprec(ipar))then begin
;
ncut(ipar)=1
xncut(ipar)=float(ncut(ipar))
top(ipar)=par(ipar) ; array dimension npar
bot(ipar)=par(ipar)
;
endif ; dcut(ipar) le parprec(ipar)
;
endif ; ncut(ipar) gt 1
;
; diagnostic
;print,'iter,ipar,ncut(ipar),dcut(ipar),bot(ipar),top(ipar) = '
;print,iter,ipar,ncut(ipar),dcut(ipar),bot(ipar),top(ipar)
;
endfor ; ipar=0,npar-1
;
iter=iter+1
;
if(max(ncut) le 1)then goto,c200
if(iter ge nitervar)then begin
print,'DETSELFCAL ending because of attainment of NITERVAR = ',nitervar 
printf,iunit,'DETSELFCAL ending because of attainment of NITERVAR = ',nitervar 
goto,c200
endif ; iter ge nitervar
;
goto, c100
;
c200:
;
;parprec=dcut ; commented out - for multiple pixel calls we want this unchanged
parmin=parmin_in
parmax=parmax_in
;
betaout=parstartall(0)
betacoeffout=parstartall(1)
betaexpout=parstartall(2)
tauoffsetout=parstartall(3)
tauout=parstartall(4)
gammaexpout=parstartall(5)
betashootout=parstartall(6)
betacoeffshootout=parstartall(7)
betaexpshootout=parstartall(8)
tauoffsetshootout=parstartall(9)
taushootout=parstartall(10)
gammaexpshootout=parstartall(11)
;
for i=0,nisolve-1 do begin
;
if(parident(i) eq 0)then betaout=par(i)
if(parident(i) eq 1)then betacoeffout=par(i)
if(parident(i) eq 2)then betaexpout=par(i)
if(parident(i) eq 3)then tauoffsetout=par(i)
if(parident(i) eq 4)then tauout=par(i)
if(parident(i) eq 5)then gammaexpout=par(i)
if(parident(i) eq 6)then betashootout=par(i)
if(parident(i) eq 7)then betacoeffshootout=par(i)
if(parident(i) eq 8)then betaexpshootout=par(i)
if(parident(i) eq 9)then tauoffsetshootout=par(i)
if(parident(i) eq 10)then taushootout=par(i)
if(parident(i) eq 11)then gammaexpshootout=par(i)
;
endfor ; i=0,nisolve-1
;
; print value of beta and tau at the maximum and minimum illuminations
; for imodel=3
;
if(imodel eq 3)then begin
ii=where(maskoutbest eq 0 and maskinbest eq 0,nii)
if(nii le 1)then begin
print,'DETSELFCAL - not enough points fitted for solution for beta,tau'
printf,iunit,'DETSELFCAL - not enough points fitted for solution for beta,tau'
goto,c999
endif ; nii le 1
test=respcorrbest(ii)*modelfitbest(ii)
smin=min(test)
smax=max(test)
stat,test,smin,smax,sq2,sq1,sq3,testsigequiv,$
testav,testsig,0
;
setshootbeta_model3,betaout,smin,betalongmin,betashortmin
print,'DETSELFCAL: SMIN,BETALONG,BETASHOOT:',$
float(smin),float(betalongmin),float(betashortmin)
printf,iunit,'DETSELFCAL: SMIN,BETALONG,BETASHOOT:',$
float(smin),float(betalongmin),float(betashortmin)
;
setshootbeta_model3,betaout,sq1,betalongq1,betashortq1
print,'DETSELFCAL: SQ1 ,BETALONG,BETASHOOT:',$
float(sq1),float(betalongq1),float(betashortq1)
printf,iunit,'DETSELFCAL: SMIN,BETALONG,BETASHOOT:',$
float(sq1),float(betalongq1),float(betashortq1)
;
setshootbeta_model3,betaout,sq2,betalongq2,betashortq2
print,'DETSELFCAL: SQ2 ,BETALONG,BETASHOOT:',$
float(sq2),float(betalongq2),float(betashortq2)
printf,iunit,'DETSELFCAL: SMIN,BETALONG,BETASHOOT:',$
float(sq2),float(betalongq2),float(betashortq2)
;
setshootbeta_model3,betaout,sq3,betalongq3,betashortq3
print,'DETSELFCAL: SQ3 ,BETALONG,BETASHOOT:',$
float(sq3),float(betalongq3),float(betashortq3)
printf,iunit,'DETSELFCAL: SMIN,BETALONG,BETASHOOT:',$
float(sq3),float(betalongq3),float(betashortq3)
;
setshootbeta_model3,betaout,smax,betalongmax,betashortmax
print,'DETSELFCAL: SMAX,BETALONG,BETASHOOT:',$
float(smax),float(betalongmax),float(betashortmax)
printf,iunit,'DETSELFCAL: SMAX,BETALONG,BETASHOOT:',$
float(smax),float(betalongmax),float(betashortmax)
;
setshoottime_model3,tauout,smin,tlongmin,tshootmin
print,'DETSELFCAL: SMIN,TLONG,TSHOOT:      ',$
float(smin),float(tlongmin),float(tshootmin)
printf,iunit,'DETSELFCAL: SMIN,TLONG,TSHOOT:      ',$
float(smin),float(tlongmin),float(tshootmin)
;
setshoottime_model3,tauout,sq1,tlongq1,tshootq1
print,'DETSELFCAL: SQ1 ,TLONG,TSHOOT:      ',$
float(sq1),float(tlongq1),float(tshootq1)
printf,iunit,'DETSELFCAL: SQ1 ,TLONG,TSHOOT:      ',$
float(sq1),float(tlongq1),float(tshootq1)
;
setshoottime_model3,tauout,sq2,tlongq2,tshootq2
print,'DETSELFCAL: SQ2 ,TLONG,TSHOOT:      ',$
float(sq2),float(tlongq2),float(tshootq2)
printf,iunit,'DETSELFCAL: SQ2 ,TLONG,TSHOOT:      ',$
float(sq2),float(tlongq2),float(tshootq2)
;
setshoottime_model3,tauout,sq3,tlongq3,tshootq3
print,'DETSELFCAL: SQ3 ,TLONG,TSHOOT:      ',$
float(sq3),float(tlongq3),float(tshootq3)
printf,iunit,'DETSELFCAL: SQ3 ,TLONG,TSHOOT:      ',$
float(sq3),float(tlongq3),float(tshootq3)
;
setshoottime_model3,tauout,smax,tlongmax,tshootmax
print,'DETSELFCAL: SMAX,TLONG,TSHOOT:      ',$
float(smax),float(tlongmax),float(tshootmax)
printf,iunit,'DETSELFCAL: SMAX,TLONG,TSHOOT:      ',$
float(smax),float(tlongmax),float(tshootmax)
endif ; imodel eq 3
;betaout=par(0)
;tauout=par(1)
;gammaexpout=par(2)
;betashootout=par(3)
;taushootout=par(4)
;gammaexpshootout=par(5)
;
signal0=signal0_in
signalshoot0=signalshoot0_in
sillum0=sillum0_in
;
gammaexp=gammaexp_in
gammaexpshoot=gammaexpshoot_in
betashoot=betashoot_in
taushoot=taushoot_in
;
betacoeff=betacoeff_in
betaexp=betaexp_in
tauoffset=tauoffset_in
betacoeffshoot=betacoeffshoot_in
betaexpshoot=betaexpshoot_in
tauoffsetshoot=tauoffsetshoot_in
;
iparsolve=iparsolve_in
;
if(icalmethod eq 2)then begin ; overwrite detector parameters in ***OVERSC
;                               arrays in common DETPARS for pixel IPIX
print,'DETSELFCAL: updating ***OVERSC arrays in common_DETPARS'
;
betaoversc(ipix)=betaout
tauoversc(ipix)=tauout
gammaexpoversc(ipix)=gammaexpout
betashootoversc(ipix)=betashootout
taushootoversc(ipix)=taushootout
gammaexpshootoversc(ipix)=gammaexpshootout
betacoeffoversc(ipix)=betacoeffout
betaexpoversc(ipix)=betaexpout
tauoffsetoversc(ipix)=tauoffsetout
betacoeffshootoversc(ipix)=betacoeffshootout
betaexpshootoversc(ipix)=betaexpshootout
tauoffsetshootoversc(ipix)=tauoffsetshootout
;
endif ; icalmethod eq 5
;
c999:
;
close,iunit
;
return
end




