pro erdtomap,arrayin,osampin,erdin,isimul,ichopcheck, idefcal, $
	n1, n2, pixplt, psplot, hdr, measpos=measpos, proc_fcs=proc_fcs, $
	VERBOSE=verbose, $
	reset_int_corr=reset_int_corr, dark_cur_subt=dark_cur_subt, $
	slin_cor=slin_cor, $
	NO_PLOT=no_plot, MROLL=mroll

;
; input from common NAMES:
; tdtnam is string denoting name of TDT eg '53801001'
; iseq is string denoting sequence number of target source map
;            (normally '01' or '04' or '07' for multifilter sequence separated
;             by FCS measurements) 
; dirnam is string denoting irectory name for internal PIA files
;            eg '/d13/vlk/rjt/pia/p32p22p25/v7_3/'
; caldir is string denoting CALG directory (needed by SIMUL32 for beams)
;            eg '/d12/vlk/cgabriel/pia_7.3/calg/'
; cfilter is either 50,60,70,90,100,105,120,135,160,180,200 (neede by SIMUL32)
; input:
; arrayin is 'c100' or 'c200'
; osampin is P32 oversampling factor (0.5,0.66,1.0,2.0 or 3.0)
; erdin = 'y' to read ERD data again = 'n' otherwise (to save time for 
;             second and subsequent runs eg when debugging
; if isimul is 1 a simulated data set (paremeters defined in SIMUL32 routine
;                        is output into S, overwriting the old data
;
; if psplot is 'ps' all plots are sent to printer via pr_open
; if ichopcheck is 1 POINT masks bad plateaus where chopper hosekeeping data
; is suspected to be wrong.
;
; example run lines from LEVI
;
; do not get into an IDL other than 5.0 beforehand (best use new terminal)
; cd /us0/vlk/rjt/pia
; tcsh
; setenv DISPLAY xpc140:0.0
; source pia_envi (assuming this has correct pointers to FITS directory etc)
; /d12/vlk/cgabriel/pia_7.3/PIA ; starts PIA under V5.0
; once in pia just open the file manager and close to get to defaultt directory
; (otherwise get into Carlos's PIA directory)
; $cp /us0/vlk/rjt/IDL/PROG/ERDTOMAP/common* . ; copy latest common blocks
; @/us0/vlk/rjt/IDL/PROG/ERDTOMAP/runerdtomap
; CERES 100 micron
; 
; erdtomap,'53801001','01','/d13/vlk/rjt/pia/p32p22p25/v7_3/','c100',1,'y',0,30,5,''
;
; to work on data after interactively from DRIFTCORR32 routine
; @common_all
; assigngrid ; (needed by driftcorr)
; tdtnam='53801001'
; iseq='01'
; dirnam='/d13/vlk/rjt/pia/p32p22p25/v7_3/'
; idefcal=0
; ndriftsolve(npix)=0
;
; CERES 160 micron
; erdtomap,'53801001','01','/d15/vlk/rjt/ERDTOMAP/DATA/','c200',1,'y',0,30,1,''
;
; example run lines from IDL
; set term/width=100
;  run logdef file where the standard PIA reduction was done - eg 
;  @data:[RJT.IA]LOGDEF_CERES_V6_1_data
;  the following line is needed since common blocks are called from the 
;  FITS ERD data directory defined by the logdef file - eg
; copy data:[RJT.IDL.proG.ERDTOMAP]common*.pro data:[rjt.pht.ceres]*.*
; cp /d15/vlk/rjt/ERDTOMAP/common*.pro /d15/vlk/rjt/ERDTOMAP/DATA/v7_3/.
; cp /home/pht/rtuffs/ERDTOMAP/common*.pro /home/pht/rtuffs/ERDTOMAP/DATA/.
; cp /home/pht/rtuffs/ERDTOMAP/DATA/IIPH53801001.FITS
;             /home/pht/rtuffs/ERDTOMAP/DATA/v7_3/IIPH53801001.FITS
; NB get out of all previous PIA sessions and start PIA again, either
; by typing
; idl (for VMS)
; or PIA (for VILSPA)
; @data:[RJT.IDL.proG.ERDTOMAP]runerdtomap
; @/d15/vlk/rjt/ERDTOMAP/runerdtomap
; @/home/pht/rtuffs/ERDTOMAP/runerdtomap
; CERES 100 micron
; erdtomap,'53801001','01','data:[RJT.IDL.proG.ERDTOMAP]','c100',1,'y',0,30,5,''
; erdtomap,'53801001','01','/home/pht/rtuffs/ERDTOMAP/DATA/v7_3/',$
;  'c100',1,'y',0,30,5,''
; CERES 160 micron
; VMS erdtomap,'57901909','01','DATA:[RJT.PHT.CERES]','c200',1,'y',0,30,1,''
; LEVI
; erdtomap,'53801001','01','/d15/vlk/rjt/ERDTOMAP/DATA/','c200',1,'y',0,30,1,''
; CASA 100 micron
; erdtomap,'24800640','04','data:[RJT.IDL.proG.ERDTOMAP]','c100',0.66,'y',0,300,5,''
; separate maps for separate readout intervals and otf settings and pixels
; (steer in form of input array of pixels and readout
; N132D 100 micron
; erdtomap,'61202259','04','data:[RJT.IDL.proG.ERDTOMAP]','c100',1.0,'y',0,300,5,''
; VCC1569 orbit 199 160um
; erdtomap,'19900544','01','DATA:[RJT.PHT.199]','c200',1,'y',0,30,1,''
;
; n1 and n2 are points for range of diagnostic plotting n1:n2. If n1 and n2
; are negative then data points encompassing the range for which the otf
; is set for the raster point -n1 -n2 will be plot (where 1 < n1 < ny
; and 1 < n2 < nz)
;
;
;
;COMMON phterd, phterd, phterd_REC
;common steerin,array,nptin,npt,ninramp,imeas,osamp
;common steer1,npix,pixsize,pixpitch,pixoff,nchop,dcy,dry,drz
;common signal,rs,cs,nch,s_in,s,badin,bad,rel,rms,glitch,jf,njf,ninchmax,rd,$
;nkf,kf,nkfmax,irelstart,nchopmed,gbad,npolyrms,nrmsmed,sigmaxfract
;common pinfo,fpt
;common timer,time
;common const,pie
;common plotter,otfstart,otfstop,rdstat,chop,step,otf,rpid,yrel,zrel,$
;ytrue,ztrue,yzrpidcen,nyraster,nzraster
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
;common flat,nflat,nrow,npixrow,ratioinrow,ratiobetweenrow,fmappix,flatrow,$
;snoflat,glitchnoflat,rmsnoflat
;common names,tdtnam,iseq,dirnam,caldir,cfilter
@common_mapstk
@common_names
@common_const
@common_flat
@common_mapper
;@common_phterd 
@phterd
@common_pinfo
@common_plotter
@common_signal
@common_steer1
@common_steerin
@common_timer
@common_filseq
; next statement added RJT 06JUL00
@common_map3dref
@common_driftpar
;CG
@phtffield
@phtsrd
@phtcap
;CG
;common driftpar,beta,tau,imodel,ndriftsolve,islewmethod,backpred,inegmethod
;
; plotting parameters
;
	plotno=1 ; =1 to suppress plots 

IF N_ELEMENTS(n1) EQ 0 THEN BEGIN
 n1=0
 n2=30
 pixplt=0
 psplot=''
ENDIF
;
; program constants
;
	pie=double(3.141592654)
	yss=200 ; plotting constant
;precotf=3.0
	precotf=2.0 ; nearness in ra, dec to otf position such that otf can be 
;             considered on (for gridding purposes on simple natural sample
;             map).  
	sigmaxfract=0.5 ; maximum fraction of signals that can be flagged bad on
                ; a chopper plateau by glitch1
	sigclipdg1=1.8 ; no. of sigmas for glitch recognition in 1st stage deglitch dg1
	niterdg1=1 ; number of iterations in 1st stage deglitch dg1 
	nglmin=4 ; minimum number of surviving points on a ramp to calculate
	nrelmin=3 ; NRELMIN is the minimum reads of each read class on a chopper plateau
;         for the chopper plateau to be included in the relativisation and rms
;         calculation

	irelstart=2 ; the relativisation in routine RELATIVISE is scaled to the 
;           average signal from the read classes IRELSTART....NiNRAMP-IRELSTART
;           the first signal (V/s) is 1 and the last NINRAMP-2 (not IDL 
;           notation). Typically for 
;           a P32 with ninramp=4 IRELSTART should be 2 but a P40 raster
;           might differ.
	nchopmed=25  ; number of plateaus to median filter the rms in FINDRMS
	npolyrms=2 ; =2 for quadratic fit to ramps subtracted to find residuals in rms
;              and in glitch1
	nrmsmed=5 ; number of points for median filtering of signal versus time 
;            on plateau (all read identifiers) prior to fitting signal
;            used in findrms and glitch1
; Note: nglmin-nrmsmed should be >=  npolyrms+2
;
	IF not KEYWORD_SET(VERBOSE) THEN verbose=0
	IF VERBOSE THEN BEGIN
		print,'ERDTOMAP: basic steering parameters:'
		print,'precotf (arcsec): ',precotf
		print,'sigclipdg1: ',sigclipdg1
		print,'sigmaxfract: ',sigmaxfract
		print,'niterdg1: ',niterdg1
		print,'nglmin: ',nglmin
		print,'nrelmin: ',nrelmin
		print,'irelstart: ',irelstart
		print,'nchopmed:      ',nchopmed
		print,'npolyrms: ',npolyrms
		print,'nrmsmed: ',nrmsmed
	ENDIF
;
; initialise  blocks
;
	array=arrayin
	osamp=osampin
	IF verbose THEN BEGIN
		print,'input parameters:'
		print,'array:      ',array
		print,'osamp:      ',osamp
		print,'n1 n2 plot range: ',n1,n2
		print,'pixplt: ',pixplt
	ENDIF

	init1,array,osamp
print,' '
;
;
; Data ingestion
;
	IF KEYWORD_SET(measpos) THEN BEGIN
	 imeas = measpos
	 tdtnam = STRMID(phterd(imeas).admn,4,8) 
	 dirnam = !FITDIR
	 ics = dirnam + 'CS' + tdtnam + '.ICS'
	 iiph= dirnam + 'IIPH' + tdtnam + '.FITS
	 
	 IF KEYWORD_SET(proc_fcs) THEN BEGIN
	   
	    PIA_disp_print_file, '', height=4, title='Process FCS meas.',$
	    	text=["Process through following menus the FCS", $
		      "measurements (up to SCP level) needed for calibration "]
 	    		 pia_genpro_top, genpr
		 SRD = 0
		 SCP = 0
		 FROM_SRD = 0
		 FROM_SCP = 0
		 AUTO_RECO = 0
		 INFO = 0
		 IF genpr.gbegin EQ 1 THEN FROM_SRD=1
		 IF genpr.gbegin EQ 2 THEN FROM_SCP=1
		 IF genpr.gend EQ 0 THEN SRD=1 ELSE $
		 IF genpr.gend EQ 1 THEN SCP=1
		 IF genpr.auto_reco THEN auto_reco=1
		 IF genpr.info EQ 1 THEN INFO=1
		 
		 pia_proc_gen, FROM_SRD=from_srd, FROM_SCP=from_scp, $
		 	SRD=srd, SCP=scp, AUTO_REC=auto_reco, SUMM_INFO=info

	   ENDIF
	 	 
	ENDIF ELSE BEGIN
		if(arrayin eq 'c100')then ierd = dirnam+'C1'+iseq+tdtnam+'.IERD'
		if(arrayin eq 'c200')then ierd = dirnam+'C2'+iseq+tdtnam+'.IERD'
		ics=dirnam+'CS'+tdtnam+'.ICS'
		iiph=dirnam+'IIPH'+tdtnam+'.FITS
		IF verbose THEN BEGIN
			print,'input data directory and files:'
			print,dirnam
			print,ierd
			print,ics
			print,iiph
		ENDIF
	ENDELSE
	
;
;  input ERD data structure
	IF (erdin eq 'y') then BEGIN
	  read_ierd,ierd
	  imeas=N_ELEMENTS(phterd) -1
	ENDIF
   	handle_value,phterd(imeas).conp,conp ; data (FLT dim npix+2,nptin)
   	handle_value,phterd(imeas).pixf,pixf ; data status (INT dim nptin)
	nptin=n_elements(pixf)
   	handle_value,phterd(imeas).time,time ; time in sec (DOUBLE dim nptin)
; VILSPA 
;   time(1:nptin-1)=time
   	handle_value,phterd(imeas).rpid,rpid ; raster position (BYTE dim 2,nptin)
   	handle_value,phterd(imeas).tkey,tkey ; internal clock (LONG dim nptin)
   	handle_value,phterd(imeas).step,sstep ; chopper step (LONG from 0 to nchop-1) (nptin)
   	handle_value,phterd(imeas).chop,cchop ; chopper Y offset in arcsec (FLOAT dim nptin)
   	handle_value,phterd(imeas).hdr,hdr ; fits file header (string)
	
	IF verbose THEN BEGIN
	   	help,cchop
		print,'nptin:      ',nptin
		print,'imeas = ',imeas
		print,min(cchop),max(cchop)
	ENDIF

	chop=double(cchop) ; to preserve pointing precision
	step=sstep ; fill common block in PLOTTER

;
; data for pixel ipix contained in array conp(ipix-1,*)
; data for open pixel contained in array conp(npix,*)
; data for resistor pixel contained in array conp(npix+1,*)
;
; set up the following data status arrays:
;
;       Sus:            Suspicious              0:no    1:yes   -1:bad
;       Chopon:         Chopper on-position     0:no    1:yes   -1:bad
;       Chops:          Chopper sign            0:-     1:+     -1:bad
;       Rdstat:         Read-out status         0:NDR   1:DR    -1:bad
;       Otf:            On-target flag          0:on target 1:off target -1:bad
;       Autdr:          Auto data reduction     0:no    1:yes   -1:bad
;
  	decode_pixf,pixf,sus,chopon,chops,rdstat,otf,autdr
;
	rd=lindgen(nptin) ; also to common block
;
	ny=long(max(rpid(0,*)))
	nz=long(max(rpid(1,*)))
	nyraster=ny ; copy into common blocks
	nzraster=nz 
	
	IF verbose THEN print,'ny,nz = ',ny,nz
;
; find ninramp, dt, ndr, npt
;
	rdpar,ndr
;rdpar,time,rdstat,dt,ndr
	dt=dtime
;dtime=dt ; now done by RDPAR
;
; correct chopper pointing and find
;      RS (=1,2,3,4,1,2,3... for reads)
; and  CS (= readout identifiers for reads when chop has moved 
; and  NCH (number of chop transitions = nch)
;
;help,chop
;help,step
	rchset,n1,n2

;
; create data array S,S_IN in V/s and mask arrays bad,badin. Oct99 rjt:
; Run this before POINT rather than after as previously so that bad chopper 
; attitude can be masked into BAD rather than to FPT as previously
;
	sigcreate,conp,rdstat,autdr,sus,dt
;
; find ra and dec and convert pointing to arcsec offsets in RA, DEC from 
; median of ra, dec on central point in raster (arrays rarel,decrel) and in 
; Y, Z (arrays yrel, zrel)
;
; get easily the CS info
	GIVE_CS, phterd(imeas), cst, rec, conv_cst
	
	point,iiph,ics,hdr,rpid,tkey,chop,step,ny,nz,precotf,$
		ra,dec,racen,deccen,rarel,decrel,yrel,zrel,$
		rpidcen,yzrpidcen,ytrue,ztrue,otfstart,otfstop,$
		ichopcheck, CST=conv_cst, MROll=mroll

; following statement commented out JUL00 RJT (now called in POINT)
;	findp32grid,ny,nz ; common MAPPER needed by simul32 and other routines
;
	if(isimul eq 1)then begin
		simul32,0 ; simulation using internal parameters set in SIMUL32
		s_in=s
	endif
;
; perform reset interval correction
	IF KEYWORD_SET(reset_int_corr) THEN BEGIN
          uncert=0
	  corr_reset_int, s_in, STRUPCASE(STRMID(array,0,2)), $
			cst.intt(rec), cst.drs(rec), $
			out_sig, corr, uncert=uncert
	  s_in = out_sig
          rel_unc = uncert
          fxaddpar, hdr,'PRS_RIN0',$
              corr.a0,' Reset interval correction: A0', $
              BEFORE='XTENSION'
          fxaddpar, hdr,'PRS_RIN1',$
              corr.a1,' Reset interval correction: A1', $
              BEFORE='XTENSION'
          fxaddpar, hdr, 'PRS_R0_S', rel_unc(0), $
              ' <Systematic rel. unc.> - Reset Int. corr. A0', $
              BEFORE='XTENSION'
          fxaddpar, hdr, 'PRS_R1_S', rel_unc(1), $
              ' <Systematic rel. unc.> - Reset Int. corr. A1', $
              BEFORE='XTENSION'

	  PRINT, 'Reset Interval correction performed'
	ENDIF

	IF KEYWORD_SET(dark_cur_subt) THEN BEGIN
	   pia_load_ierd, phterd(imeas), tmperd

	   GIVE_darkcur_orb, tmperd, darkcur
           FOR ipix=0,N_ELEMENTS(s_in(*,0))-1 DO $
	    s_in(ipix,*) = s_in(ipix,*) - darkcur(ipix) 
	   PRINT, 'Dark current correction performed ...'
           fxaddpar, hdr, 'PRS_DARK',1,'Dark Current subtracted ', BEFORE='XTENSION'
	ENDIF

	IF KEYWORD_SET(slin_cor) THEN BEGIN
	   pia_load_ierd, phterd(imeas), tmperd
	   GET_rlin, tmperd, s_in, sig_cor
	   s_in = sig_cor
	   PRINT, 'Signal linearization done ...'
	ENDIF	   	
	s = s_in
;

	jformat ; find general purpose format key
;
; first stage deglitch, relativisation, noise determination
;
	dg1,otfstart,otfstop,sigclipdg1,niterdg1,nglmin,nrelmin,n1,n2,pixplt

; following statement commented out JUL00 RJT (now called in POINT)
;	assigngrid ; needed by drift

; initialise arrays needed in further processing for driftcorrection, flat,
; calibration etc
;
; common block FILSEQ
	naotseq=10 ; make larger than the real number to avoid having to dimension this
           ; with a further inpiut parameter. Note errors will be produced if
           ; the zeros from this initialisation are not replaced by proper
           ; brighnesses before a call to DRIFTCORR with IFCS > 1.
	sillumskyprevfilter=fltarr(naotseq)
	ndriftsolve=lonarr(npix) ; common DRIFTPAR

;
; set up approximate signal non-linearity correction factors into common
; COMMON_NONLIN using GETNONLC. GETNONLC must be run before PSFVS, below.
;
	getnonlc
;
	psfvs,idefcal  ; set up point source simulation for later use in selfcal with 
;                icomposite=1. (this must be done prior to the 
;                DRIFT32 call as the ES array 
;                in the E32 common is filled in the SIMUL32 call made by
;                PSFVS). PSFVS prevents an overwrite of S however. 
;
; *** added 06JUL00 RJT
;
; make reference map cube with no weighting and only using data with OTF set
; for use in FINDILLHIST and DETINIT to substitute missing values. 
; Place arrays in common MAP3DREF.
;
print,'ERDTOMAP: creating MA3DREF'
makemapmulti,npix,lindgen(npix),map3dref,map3drefrms,map3drefd,map3drefy,$
map3drefz,map3drefn,0,1
;
; common MAPSTK
;
mapstackmask=lonarr(npix,nygrid,nzgrid)
;
; initialise SCPBLOCK
initscp
;
IF KEYWORD_SET(NO_PLOT) THEN $
   	RETURN  ; here for no plots
;
; save selected data to saveset
;ERDTOMAPSAVE,dirnam,tdtnam,iseq
;
; make simple maps for PHT32
;
;findp32grid,ny,nz ; define grid
	griddisp,ny,nz,pixplt,-1,0,psplot ; display grid with positions of data overlaid
                                  ; but no printing numbers on each s/c pointing
;;mappix=lindgen(npix) ; include all pixels
;;makemap,npix,mappix,mapbright,maprms,mapdisp,mapoffy,mapoffz,mapnum,1,-1 ; make map
; also make maps for individual pixels
; contour all data (lin. 10 levels min to max)
;;mapcontour,0,10,1.0,0,mapbright,maprms,20,psplot ; to unit 20
;
;;makemapmulti,npix,mappix,mapall,mapallrms,mmapd,mmapy,mmapz,mmapn,1,-1 
;;if(nz gt 1)then begin ; multiple plots only with 2D grids
;;mapcontourmult,1,10,1.0,0,mapall,mapallrms,psplot ; contour maps of individual pixels
;;endif ; nz gt 1
;
; plot chopper, data, pointing etc. 
;
; now set up plotting ranges for case n1 n2 negative (is so only points
; in range otfstart otfstop are plotted
;
	if(plotno eq 1)then goto, c9999
;
	if(n1 lt 0 and n2 lt 0)then begin
		nn1=-n1-1 ; to plot raster points in range 1 to ny
		nn2=-n2-1
		;print,'nn1,nn2',n1,n2
		n1=otfstart(nn1,nn2)
		n2=otfstop(nn1,nn2)
	endif
	IF verbose THEN $
		print,'data will be plotted for readout range n1 n2 = ',n1,n2
;print,'...corresponding to precotf = ',precotf 
;
;iplt=where(badin(pixplt-1,*) eq 0 and rd(*) gt n1-1 and rd(*) lt n2+1) ; for pos
iplt=where(rdstat ne 1 and rd(*) gt n1-1 and rd(*) lt n2+1) ; for pos
igplt=where(rd(*) gt n1-1 and rd(*) lt n2+1 and bad(pixplt-1,*) eq 0)
;
	if(psplot ne 'ps')then window,0,title='chop and read status, flags',$
		xs=400,ys=yss,xpos=430,ypos=1000-(yss+20)
	plot,rd(n1:n2),chop(n1:n2),yran=[-100,250],xstyle=1,ystyle=1,xtickl=1
	oplot,rd(n1:n2),rdstat(n1:n2)*40+100
	oplot,rd(iplt),badin(pixplt-1,iplt)*40+150
	oplot,rd(iplt),bad(pixplt-1,iplt)*40+200
;plot,rd(n1:n2),chop(n1:n2),yran=[-100,250],xstyle=1,ystyle=1,xtickl=1
;oplot,rd(n1:n2),rdstat(n1:n2)*40+100
;oplot,rd(n1:n2),badin(pixplt-1,n1:n2)*40+150
;oplot,rd(n1:n2),bad(pixplt-1,n1:n2)*40+200
;oplot,rd(n1:n2),chopon(n1:n2)*70
;oplot,rd(n1:n2),otf(n1:n2)*60
;
;window,1,title='s/c offset ra from map centre (arcsec)',$
;xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)*3
;plot,rd(n1:n2),rarel(n1:n2),xstyle=1,ystyle=1,xticklen=1
;
;window,2,title='s/c offset dec from map centre (arcsec)',$
;xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)*4
;plot,rd(n1:n2),decrel(n1:n2),xstyle=1,ystyle=1,xticklen=1
;
	if(psplot ne 'ps')then window,3,title='otf',$
		xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)
	plot,rd(n1:n2),otf(n1:n2),yran=[-1.5,1.5],xstyle=1,xticklen=1
;
;help,rpid
;
	if(psplot ne 'ps')then window,4,title='rpid',$
		xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)*2.0
	plot,rd(n1:n2),rpid(0,n1:n2),yran=[min([rpid(0,n1:n2),rpid(1,n1:n2)])-0.5,$
		max([rpid(0,n1:n2),rpid(1,n1:n2)]+0.5)],xstyle=1,xticklen=1
	oplot,rd(n1:n2),rpid(1,n1:n2),linestyle=1
;
	if(psplot ne 'ps')then window,1,title='s/c offset Y from map centre (arcsec)',$
		xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)*3
	plot,rd(n1:n2),yrel(n1:n2),xstyle=1,ystyle=1,xticklen=1
;
	if(psplot ne 'ps')then window,2,title='s/c offset Z from map centre (arcsec)',$
		xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)*4
	plot,rd(n1:n2),zrel(n1:n2),xstyle=1,ystyle=1,xticklen=1
;
;if(psplot ne 'ps')then window,5,title='rpid(1)',$
;xs=400,ys=yss,xpos=10,ypos=1000-(yss+20)*2
;plot,rd(n1:n2),rpid(1,n1:n2),yran=[min(rpid(1,n1:n2))-0.5,$
;max(rpid(1,n1:n2))+0.5],xstyle=1,xticklen=1
;
;
;
pistr=['1','2','3','4','5','6','7','8','9']
tit7=strarr(npix,20)
tit8=strarr(npix,17)
tit9=strarr(npix,11)
tit5=strarr(npix,18)
tit6=strarr(npix,18)
tit10=strarr(npix,26)
for i=0L,npix-1 do begin
tit8(i)='glitches pixel '+pistr(i)
tit9(i)='rms pixel '+pistr(i)
tit7(i)='input signal pixel '+pistr(i)
tit5(i)='Y position pixel '+pistr(i)
tit6(i)= 'Z position pixel '+pistr(i)
tit10(i)='deglitched signal, pixel '+pistr(i)
endfor
ip=lonarr(ninramp-1)

if(psplot ne 'ps')then window,7,title=tit7(pixplt-1),xs=400,ys=yss,xpos=430,ypos=1000-(yss+20)*2
;print,'maxmin(rd(iplt)) = ',max(rd(iplt)),min(rd(iplt))
for i=0L,ninramp-2 do begin
;ip=where(badin(pixplt-1,*) eq 0 and rs(*) eq i+1 and $
;rd(*) gt n1-1 and rd(*) lt n2+1) ; for different non-destructive reads
ip=where(rdstat ne 1 and rs(*) eq i+1 and $
rd(*) gt n1-1 and rd(*) lt n2+1) ; for different non-destructive reads
if(i eq 0)then $
plot,rd(ip),s_in(pixplt-1,ip),xstyle=1,ystyle=1,$
yran=[min(s_in(pixplt-1,iplt)),max(s_in(pixplt-1,iplt))],xran=[n1,n2],xtickl=1
if(i gt 0)then $
oplot,rd(ip),s_in(pixplt-1,ip),linestyle=i
endfor
;
if(psplot ne 'ps')then window,8,title=tit8(pixplt-1),xs=400,ys=yss,xpos=850,ypos=1000-(yss+20)*3
plot,rd(iplt),glitch(pixplt-1,iplt),xstyle=1,ystyle=1,$
yran=[min(glitch(pixplt-1,iplt)),max(glitch(pixplt-1,iplt))],$
xran=[n1,n2],xtickl=1
dd=max(glitch(pixplt-1,iplt))-min(glitch(pixplt-1,iplt))
;oplot,rd(n1:n2),bad(pixplt-1,n1:n2)*0.2*dd+0.8*dd+min(s(pixplt-1,iplt))
;oplot,rd(iplt),rms(pixplt-1,iplt),linestyle=1
;
if(psplot ne 'ps')then window,9,title=tit9(pixplt-1),xs=400,ys=yss,xpos=850,ypos=1000-(yss+20)*2
plot,rd(iplt),rms(pixplt-1,iplt),xstyle=1,ystyle=1,$
yran=[min(rms(pixplt-1,iplt)),max(rms(pixplt-1,iplt))],xran=[n1,n2],xtickl=1
;
if(psplot ne 'ps')then window,5,title=tit5(pixplt-1),xs=400,ys=yss,xpos=430,ypos=1000-(yss+20)*3
plot,rd(iplt),ytrue(pixplt-1,iplt),xstyle=1,ystyle=1,xran=[n1,n2],xtickl=1
if(psplot ne 'ps')then window,6,title=tit6(pixplt-1),xs=400,ys=yss,xpos=430,ypos=1000-(yss+20)*4
plot,rd(iplt),ztrue(pixplt-1,iplt),xstyle=1,ystyle=1,xran=[n1,n2],xtickl=1
;
if(psplot ne 'ps')then window,10,title=tit10(pixplt-1),xs=400,ys=yss,xpos=850,ypos=1000-(yss+20)
maxs=max(s(pixplt-1,igplt))
mins=min(s(pixplt-1,igplt))
diffs=maxs-mins
plot,rd(igplt),s(pixplt-1,igplt),xstyle=1,ystyle=1,$
;yran=[min(s(pixplt-1,igplt)),max(s(pixplt-1,igplt))],xran=[n1,n2],xtickl=1
;yran=[mins,(maxs+0.2*diffs)],xran=[n1,n2],xtickl=1
yran=[mins,maxs],xran=[n1,n2],xtickl=1
;dd=max(s(pixplt-1,igplt))-min(s(pixplt-1,igplt))
;oplot,rd(n1:n2),gbad(pixplt-1,n1:n2)*0.1*diffs+0.9*diffs+min(s(pixplt-1,igplt))
maxch=max(chop(n1:n2))
minch=min(chop(n1:n2))
mchdiff=maxch-minch
if(maxch gt minch)then oplot,rd(n1:n2),$
(((chop(n1:n2)-minch)*0.2*diffs/mchdiff)+(0.8*diffs)+$
min(s(pixplt-1,igplt))),linestyle=0
;
;if(psplot ne 'ps')then window,10,title=tit10(pixplt-1),xs=400,ys=yss,xpos=850,ypos=1000-(yss+20)
;plot,rd(igplt),s(pixplt-1,igplt),xstyle=1,ystyle=1,$
;yran=[min(s(pixplt-1,igplt)),max(s(pixplt-1,igplt))],xran=[n1,n2],xtickl=1
;dd=max(s(pixplt-1,igplt))-min(s(pixplt-1,igplt))
;maxch=max(chop(n1:n2))
;minch=min(chop(n1:n2))
;mchdiff=maxch-minch
;if(maxch gt minch)then $
;oplot,rd(n1:n2),((chop(n1:n2)*0.75*dd/mchdiff)+0.125*dd),linestyle=1
;
c9999:
;
return
end
