pro findkeypoint,ipix,eytrue,eztrue,keypoint
;
; input:
; 
; EYTRUE,EZTRUE(npix,neptin): pointing offsets of data from map centre 
;                             in arcsec
; IPIX:                       pixel identifier for which KEYPOINT is to be 
;                             determined
; input from common MAPPER:
; NYGRID,NZGRID               dimensions of natural P32 map
; YGRID(NYGRID):              Y position of natural map pixel in arcsec from 
;                             map centre
; ZGRID(NZGRID):              Z position of natural map pixel in arcsec from 
;                             map centre
; SGRIDY,SGRIDZ:              sampling in arcsec
;              
; output:
;
; KEYPOINT(neptin):           integer key identifier K to the nearest
;                             P32 grid direction IYNEAR IZNEAR where
;                             K=IYNEAR+IZNEAR*NYGRID            
;
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
@common_mapper
;
neptin=n_elements(eytrue(ipix,*))
keypoint=lonarr(neptin)
;
;print,'FINDKEYPOINT: ipix = ',ipix
;
for i=0L,neptin-1 do begin
;
ytest=abs(eytrue(ipix,i)-ygrid)
iynear=where(ytest eq min(ytest))
iynear=iynear(0) 
;
ztest=abs(eztrue(ipix,i)-zgrid)
iznear=where(ztest eq min(ztest))
iznear=iznear(0) 
;
keypoint(i)=IYNEAR+IZNEAR*NYGRID
;
endfor ; i
;
return
end