pro findstartdet,sig0,sill0
;
; future: have keyword to input illuminations and find effect
; of repeated chopper motions. This will need a restored map as an input.
;
; finds sig0(npix) and sill0(npix) - which define
; the state of the detector at the start of an observation
;
; input: idy(npix,nptin), idz(npix,nptin) in common
; block wherepoint. These are the pointing directions on the natural grid
; in units of the natural grid identifier. These have to be set by a previous
; call to ASSIGNGRID.
;
;common wherepoint,idy,idz
@common_wherepoint
;common signal,rs,cs,nch,s_in,s,badin,bad,rel,rms,glitch,jf,njf,ninchmax,rd,$
;nkf,kf,nkfmax,irelstart,nchopmed,gbad,npolyrms,nrmsmed,sigmaxfract
@common_signal
;
npix=n_elements(idy(*,0))
sig0=fltarr(npix)
sill0=sig0
; to find number of points in first chopper plateau nistart count
; until the plateau changes
nistart=1
c233:
if(idy(0,nistart) eq idy(0,nistart-1))then begin
nistart=nistart+1
goto,c233
endif ;  idy(0,nistart) eq idy(0,nistart-1)
istart=lindgen(nistart)
;print,'nistart= ',nistart
if(nistart le 1)then begin
print,'FINDSTARTDET: no sequence of points available - aborting'
goto, c999
endif ; nistart le 0
if(nistart lt 10)then $
print,'FINDSTARTDET: warning: number of data points found less than ',NISTART
;
for ipix=0,npix-1 do begin
;
badstart=bad(ipix,istart)
sstart=s(ipix,istart)
sig0(ipix)=median(sstart)
sill0(ipix)=sig0(ipix)
igoodstart=where(badstart eq 0,nigoodstart)
if(nigoodstart le 0)then begin
print,'FINDSTARTDET: warning: no solution possible for pixel ',ipix
goto, c999 
endif ; nigoodstart le 0
sig0(ipix)=total(sstart(igoodstart))/float(nigoodstart)
sill0(ipix)=sig0(ipix)
;
endfor ; ipix
;

;for ipix=0,npix-1 do begin ; print loop
;print,'FINDETSTART: ipix,sig0(ipix),sill0(ipix) = ',$
;ipix,sig0(ipix),sill0(ipix)
;endfor ; ipix print loop 
;
c999:
;
return
end

