   pro init1,array,osamp
;
;  sets up common block steer1. This contains
;  constants depending on detector identification and raster
;  oversampling and passes them into common steer1. These parameters
;  are needed to set up virtual grid of nominal pointing for use in deglitching
;  and detecting responsivity drifts for points with the otf raised.
;  Also puts nflat=0 in the common FLAT (a switch that can only be set once
;  so that data can be saved in FLAT by P32SIMPLEFLAT
;
; Note that DRY DRZ, the spacecraft raster step in arcsec is the commanded
; one. These parameters are overwritten in POINT according to the actual
; values derived from the IIPH data.
;
;common steer1,npix,pixsize,pixpitch,pixoff,nchop,dcy,dry,drz
;common flat,nflat,nrow,npixrow,ratioinrow,ratiobetweenrow,fmappix,flatrow,$
;snoflat,glitchnoflat,rmsnoflat
;
@common_steer1
@common_flat
;
nflat=0
;
   if(array eq 'c100')then begin
   npix=9
   nchop=13
   dcy=double(15.0) ; nominal chop step in Y
   pixsize=double(43.5)
   pixpitch=double(45.9)
   pixoff=dblarr(2,npix)
; chopper offset versus index
  choff=fltarr(nchop)
  choff=[-6.0,-5.0,-4.0,-3.0,-2.0,-1.0,0.0,1.0,2.0,3.0,4.0,5.0,6.0] * dcy
; offset in Y wrt central pixel
   pixoff(0,*)=[-1.0,-1.0,-1.0,0.0,0.0,0.0,1.0,1.0,1.0]*pixpitch 
;   pixoff(0,*)=[-1.0,0.0,1.0,-1.0,0.0,1.0,-1.0,0.0,1.0]*pixpitch 
; offset in Z wrt central pixel
   pixoff(1,*)=[-1.0,0.0,1.0,-1.0,0.0,1.0,-1.0,0.0,1.0]*pixpitch 
;print,'c100 pixoff(0,*):',pixoff(0,*)
;print,'c100 pixoff(1,*):',pixoff(1,*)
   if(abs(osamp) eq 3.) then begin
   dry=60.0 ; spacecraft raster step in Y
   drz=15.0 ; spacecraft raster step in Z
   endif ; osamp
   if(abs(osamp) eq 2.) then begin
   dry=60.0 ; spacecraft raster step in Y
   drz=23.0 ; spacecraft raster step in Z
   endif ; osamp
   if(abs(osamp) eq 1.) then begin
   dry=60.0 ; spacecraft raster step in Y
   drz=46.0 ; spacecraft raster step in Z
   endif ; osamp
   if(abs(osamp) eq 0.66) then begin
   dry=92.0 ; spacecraft raster step in Y
   drz=69.0 ; spacecraft raster step in Z
   endif ; osamp
   if(abs(osamp) eq 0.5) then begin
   dry=92.0 ; spacecraft raster step in Y
   drz=92.0 ; spacecraft raster step in Z
   endif ; osamp
   endif ;'c100'
   if(array eq 'c200')then begin
   npix=4
   nchop=7
   dcy=double(31.0) ; nominal chop step in Y
   pixsize=double(89.4)
   pixpitch=double(91.7)
   pixoff=dblarr(2,npix)
;  chopper offset versus index
   choff=fltarr(nchop)
   choff=[-3.0,-2.0,-1.0,0.0,1.0,2.0,3.0] * dcy
; offset in Y wrt central pixel
;   pixoff(0,*)=[-0.5,0.5,-0.5,0.5]*pixpitch 
   pixoff(0,*)=[0.5,-0.5,-0.5,0.5]*pixpitch 
; offset in Z wrt central pixel
;   pixoff(1,*)=[-0.5,0.5,-0.5,0.5]*pixpitch 
   pixoff(1,*)=[-0.5,-0.5,0.5,0.5]*pixpitch 
   if(abs(osamp) eq 3.) then begin
   dry=92.0 ; spacecraft raster step in Y
   drz=31.0 ; spacecraft raster step in Z
   endif ; osamp
   if(abs(osamp) eq 2.) then begin
   dry=92.0 ; spacecraft raster step in Y
   drz=46.0 ; spacecraft raster step in Z
   endif ; osamp
   if(abs(osamp) eq 1.) then begin
   dry=92.0 ; spacecraft raster step in Y
   drz=92.0 ; spacecraft raster step in Z
   endif ; osamp
   endif ;'c200'
;
return
end
