pro ktoyz,keypoint,iy,iz
;
; finds integer 1D identifier arrays in Y (IY) and Z (IZ) of map pixel
; positions on a P32 natural grid corresponding to the input KEYPOINT array.
;
; input:
;    KEYPOINT(neptin):           integer array of key identifier K to the
;                                P32 grid direction IY IZ where
;                                K=IY+IZ*NYGRID  
;    NYGRID,NZGRID (MAPPER)      dimensions of natural P32 map
;
; output:
;    IY, IZ                      integer arrays of map pixel
;                                positions on a P32 natural grid corresponding
;                                to the input KEYPOINT array.
;
@common_mapper
;common mapper,sgridy,sgridz,nygrid,nzgrid,ygrid,zgrid,errflag
;
iz=long(keypoint/nygrid) 
iy=long(keypoint-iz*nygrid) 
;
return
end