pro patcher,ipix,from0,to0,from,to
;
; overwrite S(ipix,from0:to0) with the average of good elements of
; S(ipix,from(i):to(i)) over i. BAD(ipix,from0:to0) is incremented
; by IDG2BADVALUE and DG2BAD is set to IDG2BADVALUE for (ipix,from0:to0).
; The RMS(ipix,from0:to0) array is set to the average RMS of the data used
; in the patching. 
;
; Normally from0 and to0 is the start and end of a plateau on a certain
; fine pointing, and from and to are start starting and ending points of
; other plateaus on the same fine pointing 
;
@common_dg2block
;common dg2block,idg2badvalue1,idg2badvalue2,dg2bad
@common_signal
;common signal,rs,cs,nch,s_in,s,badin,bad,rel,rms,glitch,jf,njf,ninchmax,rd,$
;nkf,kf,nkfmax,irelstart,nchopmed,gbad,npolyrms,nrmsmed,sigmaxfract
;
nplat=n_elements(from)
ninplat=to0-from0+1
patch=fltarr(ninplat)
patchrms=patch
badpatch=lonarr(ninplat)
ninpatch=badpatch
;
for i=0,ninplat-1 do begin
;
for iplat=0,nplat-1 do begin
itest=from(iplat)+i
if(itest gt to(iplat))then goto, c333
;
if(bad(ipix,itest) eq 0)then begin ; can use sample to build up composite
ninpatch(i)=ninpatch(i)+1
patch(i)=patch(i)+s(ipix,itest)
patchrms(i)=patchrms(i)+rms(ipix,itest)
endif ; bad(ipix,itest) eq 0
;
c333:
endfor ; iplat
;
if(ninpatch(i) gt 0)then begin
patch(i)=patch(i)/float(ninpatch(i))
patchrms(i)=patchrms(i)/float(ninpatch(i))
endif ; ninpatch(i) gt 0
;
endfor ; i
;
ii=where(ninpatch le 0,nii)
if(nii gt 0)then badpatch(ii)=1 ; avoid using points with no data after having
;                                 subtracted idg2badvalue2 from mask in DRIFT32
badpatch=badpatch+idg2badvalue2
;
s(ipix,from0:to0)=patch
bad(ipix,from0:to0)=badpatch
rms(ipix,from0:to0)=patchrms
dg2bad(ipix,from0:to0)=idg2badvalue2
;
return
end 



