pro vignecorr,det,cpos,x,xout
;
; program for correcting for vignetting (adapted from S Niklas vignecorr
; routine). Can be used to correct any stage of the data ERD to AAP so long
; as chopper position and data value are input
;
; input:
; det = 1 for c100 = 2 for c200
; cpos = chopper position in arcsec
; x = data value x(np,number) (for np pixels and n data points per pixel) 
;
; output:
; xout = corrected data values, same dimension as x
;
xout=x
number=n_elements(x(0,*))
if det eq 1 then begin
np = 9
endif else begin
np = 4
endelse
vc=dblarr(np,2)
corrf=dblarr(np,number)
; rjt mnflc = dblarr(np,number)
; rjt mnbrc = dblarr(np,number)
if det eq 2 then begin
 vc(0,*) = [2.09877e-06,6.66666667e-06]
 vc(1,*) = [3.82716e-06,1.85185e-06]
 vc(2,*) = [9e-07,1.3611111111e-05]
 vc(3,*) = [1.2346e-06, 4.32099e-06]
endif else begin
 vc(0,*) = [1.0, 1.481481481481e-06]
 vc(1,*) = [1.111111111e-04, 1.3333333333e-04]
 vc(2,*) = [1.888888888e-04, 3.5555555555e-04]
 vc(3,*) = [ 2.222222222222e-06, 2.34568e-06 ]
 vc(4,*) = [ 3.827e-06, 6.173e-07 ]
 vc(5,*) = [ 1.877777777e-06, 3.00444444444e-05 ]
 vc(6,*) = [ 1.9753e-06, 5.3086e-06 ]
 vc(7,*) = [ 8.64198e-07, 4.320987e-06 ]
 vc(8,*) = [ 3.08642e-06, 1.296296296e-05 ]
endelse
if det eq 2 then begin ; C200
for j=0, np-1 do begin
;     print, 'Correcting Pixel', j+1
         for i=0,number-1 do begin
             if j ne 2 then begin
                if cpos(i) le 0 then begin
                   corrf(j,i) = 1 + vc(j,0)*cpos(i)*cpos(i)
                endif else begin
                   corrf(j,i) = 1 + vc(j,1)*cpos(i)*cpos(i)
                endelse
             endif else begin
                if cpos(i) le 0 then begin
                    corrf(j,i) = 1 +  sqrt(vc(j,0)*(-cpos(i)))
                endif else begin
                    corrf(j,i) = 1 +  sqrt(vc(j,1)*cpos(i))
                endelse
;             print, cpos(i),corrf(j,i)
            endelse
; rjt           mnflc(j,i) = mnfl(j,i) * corrf(j,i)
; rjt           mnbrc(j,i) = mnbr(j,i) * corrf(j,i)
           xout(j,i) = x(j,i) * corrf(j,i)
           xout(j,i) = x(j,i) * corrf(j,i)
           if j eq 3 then begin
;           print, mnbrc(j,i) , mnbr(j,i) , corrf(j,i)
           endif
;          print, cpos(i),corrf(j,i)
          endfor
endfor
endif else begin ; C100
for j=0, np-1 do begin
;      print, 'Correcting Pixel',j+1
         for i=0,number-1 do begin
           if j eq 2 or j eq 1 then begin
             if cpos(i) le 0 then begin
                   corrf(j,i) = 1 + (vc(j,0)*(-1)*cpos(i))
             endif else begin
                   corrf(j,i) = 1 + (vc(j,1)*cpos(i))
;                   print, corrf(j,i),j
             endelse
           endif     
           if j eq 5 then begin 
               if cpos(i) le 0 then begin
                   corrf(j,i) = 1 + sqrt(vc(j,0)*(-1)*cpos(i))
               endif else begin
                   corrf(j,i) = 1 + sqrt(vc(j,1)*cpos(i))
;                   print, corrf(j,i),j
               endelse
           endif
           if j eq 7 or j eq 8 or j eq 6 or j eq 4 or j eq 3  $
                                                         
       then begin
               if cpos(i) le 0 then begin
                   corrf(j,i) = 1 + vc(j,0)*cpos(i)*cpos(i)
                endif else begin
                   corrf(j,i) = 1 + vc(j,0)*cpos(i)*cpos(i)
;                   print, corrf(j,i),j
               endelse
            endif
                if j eq 0 then begin
                   if cpos(i) le 0 then begin
                     corrf(j,i) = vc(j,0)
                   endif else begin
                    corrf(j,i) = 1 + (vc(j,1)*cpos(i)*cpos(i))
                   endelse
                endif
; rjt            mnflc(j,i) = mnfl(j,i) * corrf(j,i)
; rjt            mnbrc(j,i) = mnbr(j,i) * corrf(j,i)
                 xout(j,i) = x(j,i) * corrf(j,i)
                 xout(j,i) = x(j,i) * corrf(j,i)
;            if j eq 4 then begin
;            print, mnbrc(j,i),mnbr(j,i),corrf(j,i)
;            endif
        endfor
endfor
endelse
;
return 
end
